div.targetframe {
  font-family: Verdana, sans-serif;
  margin: 0px;
  left: 0px;
  top: 0px;
  background: black;
  position: absolute;
  overflow: hidden;
  padding: 0px;
  border: 2px inset grey;
}
div.navcontainer {
  position: absolute;
  right: 10px;
  top: 10px;
  z-index: 2;
  text-align: center;
  background: transparent;
}
div.navcontainer div.toolbar {
  height: 10px;
  background: url( "../images/toolbar.png" ) repeat-x;
  cursor: move;
}
div.navwin {
  font-size: 90%;
  left: 0px;
  font-weight: bold;
  text-align: left;
  border: 1px outset red;
  border: none;
  top: 10px;
  z-index: 2;
  opacity: 0.9;
}

div.navwin img { border: 0px; }

div.navwin div.zone {
  margin: 0px;
  background: gray;
  border: 2px solid yellow;
  cursor: move;
  z-index: 3;
}
/*
div#target{
  width: 100%;
  height: 100%;
  left: 0px;
  top:  0px;
  z-index: 0;
  cursor: wait;
  position: relative;
  background: transparent;
}
div#target img{
  margin: 0px;
  padding: 0px;
  border: 0px;
  position: absolute;
}*/

div.target{
  width: 100%;
  height: 100%;
  left: 0px;
  top:  0px;
  z-index: 0;
  cursor: wait;
  position: relative;
  background: transparent;
}
div.target img{
  margin: 0px;
  padding: 0px;
  border: 0px;
  position: absolute;
}



a.logo:link, a.logo:visited {
  text-decoration: none;
  border: none;
}
a.logo img {
  position: absolute;
  margin: 5px;
  left: 0px;
  top: 0px;
  border: none;
  cursor: help;
}
div.credit {
  position: absolute;
  margin: 10px;
  right: 0px;
  bottom: 0px;
  border-top: 1px solid #bbbbbb;
  border-bottom: 1px solid #bbbbbb;
  color: #bbbbbb;
  background: transparent;
  font-weight: bold;
  padding: 5px;
  font-size: 90%;
}
.tip {
  color: white;
  background: #222222;
  padding: 3px;
  margin: 0px;
  font-family: Verdana, sans-serif;
  font-size: 8pt;
  line-height: 1.2em;
  z-index: 2;
  position: relative;
  -moz-border-radius: 2%;
  -webkit-border-radius: 2%;
}
.tip-text h2 {
  margin-top: -0.3em;
  text-align: center;
  letter-spacing: 0.1em;
  font-size: 150%;
}
.tip-text h2 img {
  position: relative;
  top: 6px;
  margin-right: 10px;
  margin-left: -10px;
}
div.target img.background{
 z-index: -2;
 position: absolute;
} 
div.loadBarContainer {
  height: 10px;
  border: 1px solid white;
  background: black;
  opacity: 0.66;
  text-align: left;
  vertical-align: top;
}
div.loadBar {
  left: 0px;
  font-size: 9px;
  font-family: sans-serif;
  font-weight: bold;
  letter-spacing: 0.25em;
  color: black;
  border: 0px;
  background: white;
  height: 10px;
}
div.scale {
  color: #bbbbbb;
  border: 2px solid #bbbbbb;
  border-top: none;
  background: transparent;
  height: 2px;
  position: absolute;
  margin: 0px;
  left: 10px;
  bottom: 20px;
  vertical-align: top;
  font-weight: bold;
  font-size: 90%;
  text-align: center;
}
div.navbuttons {
  font-size: 50%;
  line-height: 0px;
  position: relative; /* Needed for bug in IE */
  background: #222222;
  opacity: 0.6;
  width: auto;
  padding: 5px;
  -moz-border-radius-bottomleft: 2%;
  -moz-border-radius-bottomright: 2%;
  -webkit-border-bottom-left-radius: 2%;
  -webkit-border-bottom-right-radius: 2%;
}
div.navbuttons img {
  margin-top: 2px;
  margin-left: 2px;
  cursor: pointer;
  position: relative;
}
div.navbuttons img.shiftLeft, div.navbuttons img.shiftRight { top: 18px; margin-left: -5px; margin-right: -5px; }
div.navbuttons img.shiftUp { margin-left: 0px; margin-right: 0px; }
div.navbuttons img.shiftDown { margin-top: 10px; }

img.info, div.tip img, div.navbuttons img { behavior: url(images/iepngfix.htc) } /*Fix IE PNG transparency */
