<?php

function getInverseProperty ($pid)
	{
	$this_db = new DB($GLOBALS['whichdb']);
		
	$query = "SELECT DISTINCT `t2`.`property_id` as id, `t2`.`property_name` as name " .
    "FROM property ".
		"join `property` as t2 on `property`.`property_rev` = t2.property_id  ". 
    "WHERE ".
    "`property`.`property_id` = '$pid' ";
		
	$this_db->query($query);  

  while ($myrow = $this_db->next())
    {$out = array ("id" => $myrow["id"], "name" => $myrow["name"]);}

  return ($out);
	}

function getRelatedProperties ($type_id=0, $lim=0, $ids="", $rev=false)
  {
  add2FunctionCallString ("getRelatedProperties ($type_id, $lim)");
  
  $this_db = new DB($GLOBALS['whichdb']);
  
  if ($type_id)
    {
    if (!$ids)
      {$ids = getTypeAllParents (array ($type_id), "", 3);}
     
		if ($rev)
			{$idsSQL = " `range_id` IN (".implode(",", $ids).") AND ";}
		else
			{$idsSQL = " `type_id` IN (".implode(",", $ids).") AND ";}
    }
  else {$idsSQL = " ";}  

  $query = "SELECT DISTINCT `property`.`property_id`, " .
    "`property`.`property_name` FROM property, typeProperty ".
    "WHERE $idsSQL ".
    "`property`.`property_id` NOT IN (35) AND " .
    "`property`.`property_id` = `typeProperty`.`property_id` ";

  if ($lim == "con")
    {$query .= " AND `range_id` IN (265) ";}
  else if ($lim == "txt")
    {$query .= " AND `range_id` IN (233, 263) ";}
  else if ($lim == "cap")
    {$query .= " AND `range_id` IN (263) ";}
  else if ($lim == "des")
    {$query .= " AND `range_id` IN (233) ";}
  else if ($lim == "lab")
    {$query .= " AND `range_id` IN (234, 235) ";}
  else if ($lim == "both")
    {$query .= " AND `range_id` IN (233, 263, 234, 235) ";}
  else if ($lim == "all")
    {$query .= " AND `range_id` IN (233, 263, 234, 235, 265, 55, 62) ";}
  else if ($rev)
    {$query .= " ";}
  else
    {$query .= " AND `range_id` NOT IN (233, 234, 235, 263, 265, 55, 62) ";}
  
  $query .= " ORDER BY `property`.`property_name` ASC ".
    "-- getRelatedProperties";
  
	$this_db->query($query);  
  $pids = array(); 
  while ($myrow = $this_db->next())
    {$pids[$myrow["property_id"]] = $myrow["property_name"];}

  return ($pids);
  }
  
function totalType ($type_id="", $limitByCat="", $limitByObj="", $na="") //$na => NeedsAttention
  {
  add2FunctionCallString ("totalType ($type_id, $limitByCat, $limitByObj)");
  $this_db = new DB($GLOBALS['whichdb']);

  if ($limitByObj > 0)
     {$extra = " join `triple` as t2 on thing_id = t2.subject AND ".
      "t2.predicate IN (40, 140) AND t2.object = '$limitByObj' ";}
  else {$extra = "";}

  if ($limitByCat > 0)
     {$catSQL = " join `triple` as t1 on thing_id = t1.subject AND ".
      "t1.predicate = 98 AND t1.object = $limitByCat ";}
  else {$catSQL = " ";}
  
  if ($type_id > 0)
    {$typeSQL = "WHERE thing_type = $type_id ";}
  else 
    {$not = array_merge (array(231), getTypeChildren (231));
     $typeSQL = "WHERE thing_type NOT IN (".implode(",", $not).") ";}
     
  if ($na)
    {$extra .= "join `triple` as t4 on thing_id = t4.subject AND ".
      "t4.predicate = 229 ";}

  $query = " SELECT count(`thing_type`) as no FROM thing $catSQL $extra ".
    "$typeSQL -- totalType ";

   $this_db->query( $query );
  $myrow = $this_db->next();
  
  if ($myrow['no']) {return ($myrow['no']);}
  else {return (0);}
  }

function getThingType ($id)
  {
  add2FunctionCallString ("getThingType ($id)");
  $this_db = new DB( $GLOBALS["whichdb"] );  
  
  $query = "SELECT `thing_type` FROM thing WHERE `thing_id` = '".$id."'";
  $this_db->query($query);
    
  if ($myrow = $this_db->next())
    {return ($myrow['thing_type']);}
  }
  
/*function getType ($id) This needed to be renamed getThingType
  {
  //add2FunctionCallString ("getTypeName ($id)");
  $this_db = new DB( $GLOBALS["whichdb"] );  
  
  $query = "SELECT `thing_type` FROM thing WHERE `thing_id` = '".$id."'";
  $this_db->query($query);
    
  if ($myrow = $this_db->next())
    {return ($myrow['thing_type']);}
  }*/
  
function getTypeName ($id)
  {
  //add2FunctionCallString ("getTypeName ($id)");
  $this_db = new DB( $GLOBALS["whichdb"] );  
  
  $query = "SELECT `type_name` FROM type WHERE `type_id` = '".$id."'";
  $this_db->query($query);
    
  if ($myrow = $this_db->next())
    {return ($myrow['type_name']);}
  }
    
function getThingTriples ($thing_id, $which="lab", $add="")
  {
  add2FunctionCallString ("getThingTriples ($thing_id, $which, $add)");
  $this_db = new DB( $GLOBALS["whichdb"] );   
  
  $query = "SELECT DISTINCT `property_id` FROM `typeProperty` ";  

  if ($which == "lab")
    {$query .= " WHERE `range_id` IN (234, 235) ";
     $q2x = "WHERE first.predicate = 18 ";}
  else if ($which == "txt")
    {$query .= "WHERE  `range_id` IN (233, 263) ";
     $q2x = "first.predicate = 57 ";}
  else if ($which == "des")
    {$query .= "WHERE  `range_id` IN (233) ";
     $q2x = "first.predicate = 57 ";}
  else if ($which == "cap")
    {$query .= "WHERE  `range_id` IN (263) ";
     $q2x = "first.predicate = 57 ";}
  else if ($which == "ref")
    {$query .= "WHERE `range_id` NOT IN (233, 263, 234, 235)";
     $q2x = "2 ";} 
  else 
    {$q2x = "2 ";} 

  $this_db->query($query);  
  $props = array(); 
  while ($myrow = $this_db->next())
    {$props[] = $myrow["property_id"];}
  
  $arr = getTripleChildren ($thing_id, $which, $props, $add);
  
  return ($arr);
  }
    
function getTripleChildren ($sub, $which, $props, $extra="")
  {
  add2FunctionCallString ("getTripleChildren ($sub, $which, $props, $extra)");
  $this_db = new DB($GLOBALS['whichdb']); 

  $query = " SELECT * FROM `triple` as first ".
    "WHERE first.subject = $sub";

  if ($props)
    {
    if (is_array($props))
      {$query .= " AND first.predicate IN (".implode(",", $props).")";}
    else
      {$query .= " AND first.predicate IN ($props)";}
    }

  $query .= " $extra";
  $this_db->query($query);
  //$trips = array();
  $triples = array();

  while ($myrow = $this_db->next())
    {
    $triples[] = $myrow;

    if ($which != "ref" and 
        $myrow["predicate"] != 58 and 
        $myrow["predicate"] != 100 and 
        !isRangeAControledList(getPropertyRange ($myrow["predicate"])))
      {$triples = array_merge($triples, 
        getTripleChildren($myrow["object"], $which, 0));}
    }

  return ($triples);
  }

function isRangeAControledList ($range)
  {
  add2FunctionCallString ("isRangeAControledList ($range)");
   $ids = getTypeAllParents ($range, "", 4);
 
  if (is_array($ids))
    {if (in_array(72, $ids) or in_array(227, $ids))
      {return (true);}}
  }

function getTypeParents ($type_id)
  {
  add2FunctionCallString ("getTypeParents ($type_id)");
  
  $this_db = new DB($GLOBALS['whichdb']);
  $query = "SELECT DISTINCT parent_id FROM `type` ";

  if (is_array($type_id))
    {
    if (implode(",", $type_id))
      {$query .= " WHERE `type_id` IN (".implode(",", $type_id).") ";}
    else
      {$query .= "";}
    }
  else
    {$query .= " WHERE `type_id` = '$type_id' ";}

  $query .= " -- getTypeParents";

  $this_db->query( $query );
  $results = array();

  while ($myrow = $this_db->next())
    {$results[] = $myrow['parent_id'];}

  return ($results);  
  }

function getTypeAllParents ($ids, $pids="", $wh="1")
  {  
  add2FunctionCallString ("getTypeAllParents ($ids, $pids, $wh)");
  
  if (!$pids)
    {$pids = getTypeParents ($ids);}
  else
    {$pids = getTypeParents ($pids);}

  if ($pids[0])
     {$ids = getTypeAllParents (array_merge ($ids, $pids), $pids, 5);}
  
  return ($ids);  
  }

function getTypeChildren ($type_id, $cls="", $inR="", $exclude="")
  {
  //add2FunctionCallString ("getTypeChildren ($type_id, $cls, $inR, $exclude)");
  $this_db = new DB($GLOBALS['whichdb']);
  $query = "SELECT type_id FROM `type` WHERE `parent_id` ";

  if (is_array($type_id))
     {$query .= " IN (".implode(",", $type_id).") ";}
  else
     {$query .= " = '$type_id' ";}

  if ($cls) {$query .= " AND `class` = '$cls'  ";}
  if ($inR) {$query .= " AND `includeInRange` = '$inR'  ";}
  if ($exclude) {$query .= " AND `type_id` NOT IN (231) ";} 
  $query .= " -- getTypeChildren ";

  $this_db->query( $query );
  $results = array();

  while ($myrow = $this_db->next())
    {$results[] = $myrow['type_id'];}

  return ($results);  
  }
  
function getTypeAllChildren ($ids, $cids="", $cls="", $inR="yes", $exclude=1)
  {
  //add2FunctionCallString ("getTypeAllChildren ($ids, $cids)");
  if (!is_array($ids))
     {$ids = array($ids);}
     
  if (!$cids)
    {$cids = getTypeChildren ($ids, $cls, $inR, $exclude);}
  else
    {$cids = getTypeChildren ($cids, $cls, $inR, $exclude);}

  if ($cids)
		{$ids = getTypeAllChildren (array_merge ($ids, $cids), $cids, $cls, $inR, $exclude);}

  return ($ids);  
  }


function getList ($table="category")
  {
  add2FunctionCallString ("getList ($table)");
  $this_db = new DB( $GLOBALS["whichdb"] );  
  
  if ($table == "language")
    {
    $query = "
      SELECT first.subject as `language_id`, third.object as `language_name` 
      FROM thing 
        join `triple` as first on thing_id = first.subject 
        join `triple` as second on first.object = second.subject 
        join `triple` as third on second.object = third.subject 
      WHERE 1 AND 
        thing_type = 232 AND
        first.predicate = 56 AND
        third.predicate = 58 ";}
  else
    {$query = "SELECT * FROM ".$table." ORDER BY `".$table."`.`".$table."_name` ASC ";}

  $this_db->query($query);

  $results = array(); 

  while ($myrow = $this_db->next())
    {$results[] = "\"".$myrow[$table."_id"]."\":\"".$myrow[$table."_name"]."\"";}

  return ("my".$table." = {".implode(",", $results)."};");
  }


function getPropertyRange ($property_id, $limit=array())
  {  
  add2FunctionCallString ("getPropertyRange ($property_id, $limit");
  
  if ($limit)
    {$lsql = " AND `type_id` IN (".implode(",", $limit).") ";}
  else
    {$lsql = "";}

  $this_db = new DB( $GLOBALS["whichdb"] );  
  $query = "SELECT DISTINCT `range_id` FROM typeProperty WHERE `property_id` ".
    "= '$property_id' $lsql";
  $this_db->query($query);

  $range = array();

  while ($myrow = $this_db->next())
    {$range[] = $myrow['range_id'];}

  return($range);
  }
  
function newThing ($id, $property=0)
  {
  add2FunctionCallString ("newThing ($id, $property)");
  $this_db = new DB( $GLOBALS['whichdb'] );

  if ($property) //get type_id
    {$idArr = getPropertyRange ($id);
     $id = $idArr[0];}
  
  $inQuery = "INSERT INTO `thing` (`thing_type`) ".
    "VALUES (".trim($id).")";

  $this_db->query( $inQuery ); 
  $thing_id = $this_db->last();

  return ($thing_id);  
  }

function deleteThing ($id)
  {
  add2FunctionCallString ("deleteThing ($id)");
  $this_db = new DB( $GLOBALS['whichdb'] );
  $dq = "DELETE FROM `thing` WHERE `thing_id` = '".$id."'";

  $this_db->query($dq);
  }

function updateThing ($thing_id, $id, $property=0)
  {
  add2FunctionCallString ("updateThing ($thing_id, $id, $property)");
  $this_db = new DB( $GLOBALS['whichdb'] );

  if ($property) //get type_id
    {$idArr = getPropertyRange ($id);
     $id = $idArr[0];}

  $upQuery = "UPDATE `thing` SET ".
    " `thing_type` = '".trim($id)."' ".
    "WHERE `thing_id` =$thing_id";

  $this_db->query( $upQuery ); 
  }

function newTriple ($s, $p, $o)
  {
  add2FunctionCallString ("newTriple ($s, $p, $o)");

  $this_db = new DB( $GLOBALS['whichdb'] );
  $sql = "SELECT `triple_id` FROM triple WHERE 
    subject = '".trim($s)."' AND
    predicate = '".trim($p)."' AND
    object = \"".trim(sql_sq($o))."\" COLLATE latin1_general_cs";
  $this_db->query($sql);

  if ($myrow = $this_db->next())
    {$tripleID = $myrow["triple_id"];}
  else
    {
    $inQuery = "INSERT INTO `triple` (`subject`, `predicate`, `object`) ".
      "VALUES ('".trim($s)."', '".trim($p)."', \"".trim(sql_sq($o))."\")";

    $this_db->query( $inQuery ); 
    $tripleID = $this_db->last();
    }

  return ($tripleID);  
  }
	
	

function newTripleB ($s, $p, $o)
  {
  add2FunctionCallString ("newTriple ($s, $p, $o)");

  $this_db = new DB( $GLOBALS['whichdb'] );
  $sql = "SELECT `triple_id` FROM triple WHERE 
    subject = '".trim($s)."' AND
    predicate = '".trim($p)."' AND
    object = \"".trim(sql_sq($o))."\" COLLATE latin1_general_cs";
  $this_db->query($sql);

  if ($myrow = $this_db->next())
    {//$tripleID = $myrow["triple_id"];
		}
  else
    {
    $inQuery = "INSERT INTO `triple` (`subject`, `predicate`, `object`) ".
      "VALUES ('".trim($s)."', '".trim($p)."', \"".trim(sql_sq($o))."\")";

    $this_db->query( $inQuery ); 
    $tripleID = $this_db->last();
    }

  return ($tripleID);  
  }
	

  
function checkTripleB ($s, $p, $o)
  {
  add2FunctionCallString ("checkTripleB ($s, $p, $o)");
  //echo "  Function: checkTriple ($s, $p, $o)<br>";

  $this_db = new DB( $GLOBALS['whichdb'] );
  $sql = "SELECT `triple_id` FROM triple WHERE 
    subject = '$s' AND
    predicate = '$p' AND
    object = \"".sql_sq($o)."\" COLLATE latin1_general_cs";
  $this_db->query($sql);

  if ($myrow = $this_db->next())
    {return($myrow["triple_id"]);}
  }
  
	
	  
function checkTripleC ($s, $p)
  {
  add2FunctionCallString ("checkTripleC ($s, $p)");

  $this_db = new DB( $GLOBALS['whichdb'] );
  $sql = "SELECT `triple_id` FROM triple WHERE 
    subject = '$s' AND
    predicate = '$p'";
  $this_db->query($sql);

  if ($myrow = $this_db->next())
    {return($myrow["triple_id"]);}
  }
  
function checkTriple ($s, $p, $o)
  {
  add2FunctionCallString ("checkTriple ($s, $p, $o)");
  //echo "  Function: checkTriple ($s, $p, $o)<br>";

  $this_db = new DB( $GLOBALS['whichdb'] );
  $sql = "SELECT `triple_id` FROM triple WHERE 
    subject = '$s' AND
    predicate = '$p' AND
    object = \"".sql_sq($o)."\" COLLATE latin1_general_cs";
  $this_db->query($sql);

  $this_db2 = new DB( $GLOBALS['whichdb'] );
  $sql2 = "SELECT `triple_id` FROM triple WHERE 
    subject = '$s' AND
    predicate = '$p'";
  $this_db2->query($sql2);

  if ($myrow = $this_db->next())
    {$tripleID = $myrow["triple_id"];}
  else if ($myrow = $this_db2->next())
    {$tripleID = $myrow["triple_id"];
     updateTriple ($tripleID, $s, $p, $o);}
  else
    {
    $inQuery = "INSERT INTO `triple` (`subject`, `predicate`, `object`) ".
      "VALUES ('$s', '$p', \"".sql_sq($o)."\")";

    $this_db->query( $inQuery ); 
    $tripleID = $this_db->last();
    }

  return ($tripleID);  
  }
  

function getTriple ($id)
  {
  add2FunctionCallString ("getTriple ($id)");

  $this_db = new DB( $GLOBALS['whichdb'] );
  $sql = "SELECT * FROM triple WHERE 
    triple_id = '$id'";
  $this_db->query($sql);

  if ($myrow = $this_db->next())
    {return($myrow);}  
  }

function deleteTriple ($id)
  {
  add2FunctionCallString ("deleteTriple ($id)");
  $this_db = new DB( $GLOBALS['whichdb'] );
  $dq = "DELETE FROM `triple` WHERE `triple_id` = '".$id."'";
  $this_db->query($dq);
  }

function updateTriple ($id, $s, $p, $o)
  {
  add2FunctionCallString ("updateTriple ($id, $s, $p, $o)");
  $this_db = new DB( $GLOBALS['whichdb'] );

  $upQuery = "UPDATE `triple` SET ".
    " `subject` = '".trim($s)."', ".
    " `predicate` = '".trim($p)."', ".
    " `object` = \"".trim(sql_sq($o))."\" ".
    "WHERE `triple`.`triple_id` =$id";

  $this_db->query( $upQuery ); 
  }
  
function deleteAll ($thing_id)
  {
   
  // Purpose of this function is to find and remove all labels and 
  // comments associated to the $thing, then identify and remove all 
  // related things and triples. Then remove all ref to and from the 
  // thing.
   
  $this_db = new DB( $GLOBALS["whichdb"] );  
  $this_db2 = new DB( $GLOBALS["whichdb"] );  
  
  $propArr = getRelatedProperties (0, "all");
	
  $props = implode(",", array_keys($propArr));
	  
  $query = "
    SELECT 
`t1`.`triple_id` AS `tid1` , 
`t1`.`subject` AS `sub1` , 
`t1`.`predicate` AS `pre1` , 
`t1`.`object` AS `obj1`,
 
`t2`.triple_id AS `tid2` , 
`t2`.subject AS `sub2` , 
`t2`.predicate AS `pre2` , 
`t2`.object AS `obj2`,
 
`t3`.triple_id AS `tid3` , 
`t3`.subject AS `sub3` , 
`t3`.predicate AS `pre3` , 
`t3`.object AS `obj3`

FROM thing
JOIN `triple` AS
t1 ON thing_id = `t1`.`subject`
JOIN `triple` AS
`t2` ON t1.object = `t2`.subject
JOIN `triple` AS
`t3` ON t2.object = `t3`.subject

WHERE 1
AND thing_id = $thing_id
AND `t1`.`predicate`
IN ( $props )
";

  $query2 = "
    SELECT 
`t1`.`triple_id` AS `tid1` , 
`t1`.`subject` AS `sub1` , 
`t1`.`predicate` AS `pre1` , 
`t1`.`object` AS `obj1`, 
`t3`.`property_name` AS `pre1_name`

FROM thing
JOIN `triple` AS
t1 ON thing_id = `t1`.`subject`
JOIN `property` AS
`t3` ON t1.predicate = `t3`.property_id

WHERE 1
AND thing_id = $thing_id
AND `t1`.`predicate`
NOT IN ( $props )
";

  $query3 = "
    SELECT 
`t1`.`triple_id` AS `tid1` , 
`t1`.`subject` AS `sub1` , 
`t1`.`predicate` AS `pre1` , 
`t1`.`object` AS `obj1`

FROM `triple` AS t1

WHERE 1
AND `t1`.`object` = $thing_id
AND `t1`.`predicate` NOT IN ( $props )
"; 
	 
  $rthings = array();
  $rtriples = array();

	//Search for all names, identifiers, etc ..
  $this_db->query($query);
  while ($myrow = $this_db->next())
    {
		$rthings[$myrow["sub1"]] = $myrow["sub1"];
    $rtriples[$myrow["tid1"]] = $myrow["tid1"];
      
		//Check if the actual values are used elsewhere, 
		//if they are dont add them for deletion
		if (additionalLinkCheck ($myrow["sub1"], $props, $myrow["obj1"]))
      {$rtriples[$myrow["tid2"]] = $myrow["tid2"];
       $rtriples[$myrow["tid3"]] = $myrow["tid3"];  
       $rthings[$myrow["sub2"]] = $myrow["sub2"];
       $rthings[$myrow["sub3"]] = $myrow["sub3"];}    
    }

  //Search for all straight references from this thing
  $this_db->query($query2);
  
  while ($myrow = $this_db->next())
    {$rtriples[$myrow["tid1"]] = $myrow["tid1"];} 
    	
  //Search for all straight references to this thing 
  $this_db->query($query3);
  
  while ($myrow = $this_db->next())
    {$rtriples[$myrow["tid1"]] = $myrow["tid1"];}
 
 	$ar1 = array();
  $ar2 = array();
  $ar1sql = array();
  $ar2sql = array();
  foreach ($rthings as $key => $id1)
			{
			$tt = getThingType ($id1);
			$tn = getTypeName ($tt);
      $ar1[$id1] = "array ('ID'=>'$id1',  'Type'=>'$tt', 'TypeName'=>'$tn')"; 
      $ar1sql[] = "('$id1',  '$tt')"; 
     	deleteThing ($id1);
      }
			
  foreach ($rtriples as $key => $id2)
			{
			$ct = getTriple ($id2); 
      $ar2[$id2] = "array ('subject'=>'".$ct['subject']."',  'predicate'=>'".$ct['predicate']."', 'object'=>'".$ct['object']."')"; 
      $ar2sql[] = "('".$ct['subject']."',  '".$ct['predicate']."', '".sql_prep($ct['object'])."')"; 
     	deleteTriple ($id2);
      }
      
  $record = ""."things = array (".implode(",\n", $ar1).");\n\n";
	
	$record .= "\nINSERT INTO \`".$GLOBALS["whichdb"]."\`.\`thing\` (\`thing_id\` , \`thing_type\`) VALUES \n".implode(", \n", $ar1sql).";\n\n";
  $record .= ""."triples = array (".implode(",\n", $ar2).");\n";
	$record .= "\nINSERT INTO \`".$GLOBALS["whichdb"]."\`.\`triple\` (\`subject\` , \`predicate\`, \`object\`) VALUES \n".implode(", \n", $ar2sql).";\n\n";
  
  return ($record);
  }

function additionalLinkCheck ($subject, $predicates, $object)
  { 
  $this_db = new DB( $GLOBALS["whichdb"] );
  $query = "SELECT * From `triple` WHERE " .
    "subject != $subject AND ".
    "object = $object AND ".
    "predicate IN ( $predicates ) ";
    
  $this_db->query($query);
  $myrow = $this_db->next();

  if (!$myrow)
    {return (1);}
  }

function newLabCom ($oid, $which, $pre, $value, $lan)
  {
  add2FunctionCallString ("newLabCom ($oid, $which, $pre, $value, $lan)");
  if ($which == 233 or $which == 263)
    {$v1 = 55;
     $v2 = 57;}
  else
    {$v1 = 56;
     $v2 = 18;}  

  $this_db = new DB( $GLOBALS['whichdb'] );
 
  $sql = "
SELECT  t3.subject as `t3s` 
FROM thing 
join `triple` as t1 on 
  thing_id = t1.subject AND 
  t1.predicate = $pre AND 
  thing_id = $oid  
join `triple` as t2 on 
  t1.object = t2.subject 
join `triple` as t3 on 
  t2.object = t3.subject AND 
  t3.predicate = 58  
join `triple` as t4 on 
  t2.object = t4.subject  AND 
 t4.object = '$lan'
"; 
  
  $this_db->query($sql);

  if ($myrow = $this_db->next())
    {$id2 = $myrow["t3s"];}
  else
    {$id1 = newThing ($which); // 235 Identifier
     $id2 = newThing ($v1); // Label
     $tid = newTriple ($oid, $pre, $id1);  
     $tid = newTriple ($id1, $v2, $id2);
     $tid = newTriple ($id2, 100, $lan);}

  $tid = checkTriple ($id2, 58, $value); 
  }
  
function getIDbyIdentifier ($tt="", $value, $nn=0)
  {
  //add2FunctionCallString ("getIDbyIdentifier ($tt, $value)");
  $this_db = new DB( $GLOBALS["whichdb"] );  
  
  if ($tt)
    {$ts = " thing_type = $tt AND ";}
  else
    {$ts = " ";}

  $sql = "
SELECT t1.subject as `t1s`
FROM thing 
join `triple` as t1 on thing_id = t1.subject AND t1.predicate = 17
join `triple` as t2 on t1.object = t2.subject
join `triple` as t3 on t2.object = t3.subject
WHERE 1 AND 
 $ts
 t3.predicate = 58 AND
 t3.object = '$value' ";

  $this_db->query($sql);

  if ($myrow = $this_db->next())
    {$thingID = $myrow["t1s"];}
  else if ($nn)
    {$thingID = 0;}
  else
    {
    $thingID = newThing ($tt); // 12 is the type id for paintings
     newLabCom ($thingID, 235, 17, $value, 1);}

  return ($thingID);  
  }
  
  
function checkIdentifier ($value)
  {
  add2FunctionCallString ("getIDbyIdentifier ($value)");
  $this_db = new DB( $GLOBALS["whichdb"] );  

  $sql = "
SELECT t1.subject as `t1s`
FROM thing 
join `triple` as t1 on thing_id = t1.subject AND t1.predicate = 17
join `triple` as t2 on t1.object = t2.subject
join `triple` as t3 on t2.object = t3.subject
WHERE  
 t3.predicate = 58 AND
 t3.object = '$value' ";

  $this_db->query($sql);

  if ($myrow = $this_db->next())
    {$thingID = $myrow["t1s"];}
  else
    {$thingID = "";}

  return ($thingID);  
  }

function getLinked ($sID="", $oID="", $wh=array(40, 140), $type=array())
  {
  add2FunctionCallString ("getLinked ($sID, $oID, $wh, $type)");
  $fdb = new DB( $GLOBALS["whichdb"] );  
  $whCS = implode(",", $wh);
  $typeCS = implode(",", $type);
  $tsql = "";
  $sql = array();

  if ($sID)
    {
    if ($typeCS)
      {$tsql = "
 join `thing` as t2 on
  t1.object = t2.thing_id AND
  t2.thing_type IN ($typeCS)";}

    $sql[] = "
 SELECT t1.object as `thisID`
 FROM thing 
 join `triple` as t1 on 
  thing_id = t1.subject AND 
  t1.predicate IN ($whCS) AND 
  thing_id = $sID 
 $tsql";
    }
		
  if ($oID)
    {
    if ($typeCS)
      {$tsql = "
  AND thing_type IN ($typeCS)";}

    $sql[] = "
SELECT t1.subject as `thisID`
FROM thing 
join `triple` as t1 on 
  thing_id = t1.subject AND 
  t1.predicate IN ($whCS) AND 
  t1.object = $oID 
$tsql";}

  $linked = array();
	
  foreach ($sql as $key => $value) 
    {$fdb->query($value." -- getLinked");		 
     while ($myrow = $fdb->next())
      {$linked[] = $myrow["thisID"];}}  
	
  return ($linked);  
  }
  
function getLabCombyID ($ID, $wh=17, $lan=1)
  {
  //add2FunctionCallString ("getLabCombyID ($ID, $wh, $lan)");
  $this_db = new DB( $GLOBALS["whichdb"] );  

  $sql = "
SELECT t3.object as `t3o`
FROM thing 
join `triple` as t1 on 
  thing_id = t1.subject AND 
  t1.predicate = '$wh' AND 
  thing_id = '$ID'
join `triple` as t2 on 
  t1.object = t2.subject
join `triple` as t3 on 
  t2.object = t3.subject AND 
  t3.predicate = 58
join `triple` as t4 on 
  t2.object = t4.subject AND 
  t4.predicate = 100 AND 
  t4.object = '$lan' -- getLabCombyID ";

  $this_db->query($sql);

  if ($myrow = $this_db->next())
    {return ($myrow["t3o"]);}  
  }
	
 
function getLabCombyID_M ($ID, $wh=17)
  {
  //add2FunctionCallString ("getLabCombyID ($ID, $wh, $lan)");
  $this_db = new DB( $GLOBALS["whichdb"] ); 
	
	if (is_array($ID))
		{$str = "IN ( ".implode (", ", $ID).") ";}
	else
		{$str = "= '$ID' ";} 

  $sql = "
SELECT t3.object as `t3o`,  t4.object as `t4o`
FROM thing 
join `triple` as t1 on 
  thing_id = t1.subject AND 
  t1.predicate = '$wh' AND 
  thing_id $str 
join `triple` as t2 on 
  t1.object = t2.subject
join `triple` as t3 on 
  t2.object = t3.subject AND 
  t3.predicate = 58
join `triple` as t4 on 
  t2.object = t4.subject AND 
  t4.predicate = 100 -- getLabCombyID 
	";

	//echo "$sql<br>";
  $this_db->query($sql);

	$arr = array();
	
	
	while ($myrow = $this_db->next())
    {$arr[] = $myrow["t3o"];}
		
	return ($arr);  
  }
  
   
function getAllLabCombyID ($ID, $wh=17)
  {
  //add2FunctionCallString ("getAllLabCombyID ($ID, $wh, $lan)");
  $this_db = new DB( $GLOBALS["whichdb"] );  

  $sql = "
SELECT t3.object as `t3o`, t4.object as `t4o`
FROM thing 
join `triple` as t1 on 
  thing_id = t1.subject AND 
  t1.predicate = '$wh' AND 
  thing_id = '$ID'
join `triple` as t2 on 
  t1.object = t2.subject
join `triple` as t3 on 
  t2.object = t3.subject AND 
  t3.predicate = 58
join `triple` as t4 on 
  t2.object = t4.subject AND 
  t4.predicate = 100 
ORDER BY t4.object DESC -- getAllLabCombyID ";

  $this_db->query($sql);

  $output = array();
  
  $no = 0;
  
  while ($myrow = $this_db->next())
    {$output[0][$no] = $myrow["t3o"];
     $output[1][$no] = $myrow["t4o"];
     $no++;}
    
	if ($no) {return ($output);}
	else {return (array(false, false));}
  }

function getRefbyID ($ID, $wh=17)
  {
  //add2FunctionCallString ("getRefbyID ($ID, $wh)");
  $this_db = new DB( $GLOBALS["whichdb"] );  

  $sql = "
SELECT t1.object as `t1o`
FROM thing 
join `triple` as t1 on 
  thing_id = t1.subject AND 
  t1.predicate = '$wh' AND 
  thing_id = '$ID' -- getRefbyID ";

  $this_db->query($sql);

  if ($myrow = $this_db->next())
    {return ($myrow["t1o"]);}  
  }

function getIDbyRef ($val, $wh=17)
  {
  $this_db = new DB( $GLOBALS["whichdb"] );  

  $sql = "
SELECT thing_id as `tid`
FROM thing 
join `triple` as t1 on 
  thing_id = t1.subject AND 
  t1.predicate = '$wh' AND 
  t1.object = '$val' -- getIDbyRef ";

  $this_db->query($sql);

  if ($myrow = $this_db->next())
    {return ($myrow["tid"]);}  
  }
  

function getRefsbyID ($ID, $wh=17)
  {
  //add2FunctionCallString ("getRefbyID ($ID, $wh)");
  $this_db = new DB( $GLOBALS["whichdb"] );  

  $sql = "
SELECT t1.object as `t1o`
FROM thing 
join `triple` as t1 on 
  thing_id = t1.subject AND 
  t1.predicate = '$wh' AND 
  thing_id = '$ID' -- getRefbyID ";

  $this_db->query($sql);

  $out = array ();
  
  while ($myrow = $this_db->next())
    {$out[] = $myrow["t1o"];}  
    
  return ($out);
  }
  

function getRefbyIDRestrictedbyType ($ID, $type, $wh=17)
  {
  //add2FunctionCallString ("getRefbyID ($ID, $wh)");
  $this_db = new DB( $GLOBALS["whichdb"] );  

  $sql = "
SELECT t1.object as `t1o`
FROM thing 
join `triple` as t1 on 
  thing_id = t1.subject AND 
  t1.predicate = '$wh' AND 
  thing_id = '$ID' 
join `thing` as lim on 
  `t1`.`object` = lim.thing_id AND 
  lim.thing_type = '$type' -- getRefbyIDRestrictedbyType ";

  $this_db->query($sql);
  
  $arr = array();

  while ($myrow = $this_db->next())
    {$arr[$myrow["t1o"]] = getLabCombyID ($myrow["t1o"]);}
    
  return ($arr);
  }
	
	
function uriPrep ($name, $id="", $pref="RC", $i="")
	{
	// Replace double quotes with single ones avoids 
	$str = ereg_replace ("[&]", "And", $name);
	$str = ereg_replace ("[ ]", "_", $str);
	$str = ereg_replace ("http://", "", $str);
	$str = ereg_replace ("[/]", "_", $str);

	//Make proper uri for 8 and 16 bit
	if ($str == "8" or $str == "16")
			{$str = $str."-bit";}	
	
	$str = rawurlencode ($str);
	
	if ($id)
		{
		if ($pref == "RC" or $pref == "RCL")
			{$str =  ucwords ($str);}
		else
			{$str = strtolower($str);}
		
		if (!$str)
			{$str = $pref."B.RRR_Blank";}
		else if ($str == "Thing" and $id == 57)
			{$str = "RC57.RRR_Entity";}
		else
			{$str = $pref.$id.$i.".".$str;}
		}
	else
		{
		ereg ( "^([0-9]+).*", $str, $var);
	
		if ($var[1])
			{$str = "RRR_".$str;}
	
		if (!$str) {$str = "RCB.RRR_Blank";}
		}
		
	return ( $str );
	}
	
	// */
?>
