<?php

/*  ******Functions included in functions_inputs:******
 *
 * area_input  ( $name, $value, $rows = "0", $cols = "0", $readonly ="", $text="")
 * enum_input  ( $name, $table, $sufix, $selected = "", $which_db = "test_ngbuild", $text="", $text_width="", $readonly="", $remove="")
 * file_input  ($name, $text, $text_width = "", $max_value = "20000000000")
 * general_input  ( $type, $name, $value, $size = "0", $max = "", $align = "", $readonly = "", $text="", $text_width="" )
 * no_select  ( $no, $name, $selected = "", $size="0", $tag="" )
 * no_select_check  ( $value, $other_value, $size)
 * search_option  ( $text, $inputs = "", $text_width = "200"  )
 * select_input  ( $name, $table, $selected = "", $user_id = "", $which_db = "test_ngbuild", $size = "0", $text="", $text_width="", $multiple="", $readonly="", $condition="")
 * zNOTUSED_select_hours  ( &$tpl, $variable, $output, $selected )
 * zNOTUSED_select_hours_b  ( $p_id, $name, $selected = "" )
 * zNOTUSED_select_pigment  ( $name, $v_project_id, $selected)
 * zNOTUSED_session_input  ( $user_id = "" )
 *
 */


function area_input ( $name, $value, $rows = "0", $cols = "0", $readonly ="", $text="")
{

if ($text)
	{
	$tag = "<tr><td style='white-space: nowrap;'><b>$text</b></td></tr>";
	}
	
ob_start();
    ?>
	<table><?=$tag?><tr><td>
    	<textarea rows=<?=$rows?>  name=<?=$name?> cols="<?=$cols?>" <?=$readonly?>><?=$value?></textarea><br>
    </td></tr></table>
    <?
$html = ob_get_contents();
ob_end_clean(); // Don't send output to client
return ($html);
}

function check_input ( $name, $value, $readonly ="", $text="")
{
if ($text)
	{$tag = "<td style='white-space: nowrap;'><b>$text</b></td>";}

if ($value)
	{$chk = "CHECKED";}
	
ob_start();	
echo <<<END
<table border="0"><tr>$tag<td>
	<input type="checkbox" name="$name" $chk $readonly/>
</td></tr></table>
END;
$html = ob_get_contents();
ob_end_clean(); // Don't send output to client
return ($html);
}

function enum_input ( $name, $table, $sufix, $selected = "", $which_db = "ng_build", $text="", $text_width="", $readonly="", $remove="", $extra="")
	{
	//Produces a complete html select input, from $table in the current databse.
	//this allows for mupltiple unequely names select inputs.

	$db = new DB( "$which_db");
	$query = "SHOW COLUMNS FROM $table LIKE '$table$sufix'";
	$result=mysql_query($query);
	if(mysql_num_rows($result)>0)
		{
		$row=mysql_fetch_row($result);
		$options=explode("','",preg_replace("/(enum|set)\('(.+?)'\)/","\\2",$row[1]));
		asort($options);
		reset($options);
		}

	if ($text)
		{
		$tag = "<td width=\"$text_width\" style='white-space: nowrap;'><b>$text</b></td>";
		}
	
	$default = "<option value=\"\" >  ---  </option>";
	

	if ($readonly)
		{
		$count = strlen($selected);
		$size = $count + 2;
		ob_start();
		?>
		<table><tr><?=$tag?><td>
			<input type="text" id="<?=$name?>" name="<?=$name?>" value="<?=$selected?>" size="<?=$size?>" <?=$readonly?> />
		</td></tr></table>
		<?
		$html = ob_get_contents();
		ob_end_clean(); // Don't send output to client
		}		
	else
		{
		
		ob_start();
    	?>
		<table><tr><?=$tag?><td>
    		<select size="0" id="<?=$name?>" name="<?=$name?>" $extra>
			<?=$default?>
		<?					 
		foreach ($options as $key => $value) 
			{  
				 
			if ($remove == $value)
				{}
			else
				{ 
				if ($value == $selected)
					{
					$chosen = "SELECTED";
					}              
				else
					{
					$chosen = "";
					}
					             
				?><option <?=$chosen?> value="<?=$value?>" ><?=$value?></option><?
				}
			}
		?>
    		</select>
    	</td></tr> </table>
 		<?
    	$html = ob_get_contents();
    	ob_end_clean(); // Don't send output to client
		}
	return ($html);
	}


function file_input ($name, $text="", $text_width = "", $max_value = "", $orientation = "LR" )
	{
	if ($text)
		{$tag = "<tr><td width=\"$text_width\" style='white-space: nowrap;'><p>$text</p></td>";}
	else
		{$tage = "<tr>";}
		
	if ($orientation == "LR")
		{$var = "</td><td>";}
	else
		{$var = "</td></tr><tr><td>";}

	ob_start();
	?>
	<table><?=$tag?><td><input type="hidden" name="MAX_FILE_SIZE" value="<?=$max_value?>"/><?=$var?>
		<input type="file" name="<?=$name?>"/>
	</td></tr></table>
	<?
	
    	
	$html = ob_get_contents();
    ob_end_clean(); // Don't send output to client
	return ($html);	
	}
	


function general_input ( $type, $name, $value, $size = "0", $max = "", $align = "", $readonly = "", $text="", $text_width="" )
{

if ($align)
	{$align_text = " align=\"$align\"";}
else
	{$align_text = "";}
	
if ($text)
	{$tag = "<td $align_text width=\"$text_width\" style='white-space: nowrap;'><b>$text</b></td>";}
else
	{$tag = "";}
	
if ($max)
	{$maxlength = "maxlength=\"$max\"";}
else
	{$maxlength = "";}
	
ob_start();

if ($type == "hidden")
	{
?>
		<input type="<?=$type?>"  name="<?=$name?>" value="<?=$value?>" size="<?=$size?>" <?=$maxlength?> <?=$readonly?> />
<?
	}
else
	{
?>
<table border="0">
	<tr>
		<?=$tag?>
		<td>
		<input type="<?=$type?>"  name="<?=$name?>" value="<?=$value?>" size="<?=$size?>" <?=$maxlength?> <?=$readonly?> />
		</td>
	</tr>
</table>
<?
	}
$html = ob_get_contents();
ob_end_clean(); // Don't send output to client
return ($html);
}
	


function form_submit ( $name="", $text="", $goto, $array="", $image="", $more="" )
{

if ($name)
	{
	$form_name = "form_".$name;

	if ($array)
		{$values = post_array ($array);}
	else
		{$values = "";}
	
	if ($image)
		{
		$type = "image";
		$extra = "SRC=\"$image\" height=\"50\"";
		$inp = "<input type=\"$type\" $extra name=\"$name\" value=\"$text\"/>";
		}
	else
		{
		$inp = "<a class=\"info_link\" onclick=\"document.$form_name.submit();\">$text</a>";
		}
	
	if ($more)
		{$other_code = "<td>$more</td>";}
	else
		{$other_code = "";}
		
	ob_start();
	echo <<<END
	<table border="0" cellspacing="0" cellpadding="0">
		<tr>
			<td style='white-space: nowrap;'>
				<form name="$form_name" enctype="multipart/form-data" action="$goto" method="post">
				$inp
				$other_code
				$values</form></td>
		</tr>
	</table>
END;
	$html = ob_get_contents();
	ob_end_clean(); // Don't send output to client
	return ($html);
	}
else
	{return ("");}
}


	
	
	
function no_select ( $no, $name, $selected = "", $size="0", $tag="" )
{
    ob_start();
	
	if ($size > 0)
		{
		$multiple = "MULTIPLE";
		$array = "[]";
		}
	else
		{}
		
    ?>
 <table>
    <tr>
        <td>
        <select size="<?=$size?>" name="<?=$name?><?=$array?>" <?=$multiple?>>
    <?

	$arr = array();
    for ($i=1; $i<($no+1); $i++)
        {
	    $select = no_select_check ($i, $selected, $size);
	?>
            <option value="<?=$i?>" <?=$select?>><?=$tag?> <?=$i?></option>
	<?
        }
	?>
        </select>
        </td>
    </tr>
 </table>
 <?
    $html = ob_get_contents();
    ob_end_clean(); // Don't send output to client
	return ($html);
}

//Sub function of no_select.
function no_select_check ( $value, $other_value, $size)
	{
	if ($size > 0)
		{
		if (in_array ($value, $other_value))
			{$output = "selected";}
		else
			{$output = "";}
		}
	else
		{
		if ($value == $other_value)
			{$output =  "selected";}
		else
			{$output = "";}
		}
	
	return ($output);
	}

	
// This form creates the html for each individual menu option used in the navigating pages.
function search_option ( $text, $inputs = "", $text_width = "200"  )

{

$session_id = session_id();
ob_start();

?>
<tr align="left"><td width="<?=$text_width?>" style='white-space: nowrap;'><h3><?=$text?></h3></td><td><?=$inputs?></td></tr>
<?

$html = ob_get_contents();
ob_end_clean(); // Don't send output to client

return ($html);
}


function select_array ( $name, $array, $selected = "", $size = "0", $text="", $text_width="", $multiple="", $readonly="", $onchange="", $script="", $fn="")
{
	//Produces a complete html select input, from $table in the current databse.
	//this allows for mupltiple unequely names select inputs.

	if ($text)
		{$tag = "<td width=\"$text_width\" style='white-space: nowrap;'><b>$text</b></td>";}
	if (!$size)
		{$size = "0";}
	if ($onchange and $script)
		{
		$onchange = "onchange=\"$script\"";
		$new = "</td><td><input type=\"button\" onclick=\"$script\" name=\"refresh\" value=\"Refresh\">";
		}
	elseif ($onchange)
		{
		$onchange = "onchange=\"submit()\"";
		$new = "</td><td><input type=\"submit\"  name=\"refresh\" value=\"Refresh\"/>";
		}

	if ($readonly)
		{
		$count = strlen($value);
		$size = $count + 2;
		ob_start();
		?>
		<table><tr><?=$tag?><td>
			<input type="text"  name="read_only" value="<?=$selected?>" size="<?=$size?>" <?=$readonly?> />
			<input type="hidden"  name="<?=$name?>" value="<?=$selected?>"/>
		</td></tr></table>
		<?
		$html = ob_get_contents();
		ob_end_clean(); // Don't send output to client
		}				
	else
		{
		foreach ($array as $key => $value)
			{
			if ($selected == $key)
				{$select = "SELECTED";}
			else
				{$select = "";}
			$options = "$options".
					   "<option value=\"$key\" $select>$value</option>";
			}
		//onchange="alert('This message is appearing because of the onchange event')"	
		ob_start();
    	?>
		<table><tr><?=$tag?><td>
    		<select size="<?=$size?>" id="<?=$name?>" name="<?=$name?>" <?=$multiple?> <?=$onchange?>>
	    	<?=$options?>
    		</select><?=$new?>
    	</td></tr> </table>
 		<?
    	$html = ob_get_contents();
    	ob_end_clean(); // Don't send output to client
		}
	
	return ($html);
}


function select_input ( $name, $table, $selected = "", $user_id = "", $which_db = "ng_build", $size = "0", $text="", $text_width="", $multiple="", $readonly="", $condition="")
{
	//Produces a complete html select input, from $table in the current databse.
	//this allows for mupltiple unequely names select inputs.

		$db = new DB( "$which_db");

	if ($text)
		{
		$tag = "<td width=\"$text_width\" style='white-space: nowrap;'><b>$text</b></td>";
		}
	if (!$size)
		{
		$size = "0";
		$default = "<option value=\"\" >  ------  </option>";
		}

	if ($readonly)
		{
		$value = $db->select_input_name($table, $selected, "", "", "_name", $condition, $readonly );
		
		if ($value)
			{
			$count = strlen($value);
			$size = $count + 2;
			ob_start();
			?>
			<table><tr><?=$tag?><td>
				<input type="text"  name="read_only" value="<?=$value?>" size="<?=$size?>" <?=$readonly?> />
				<input type="hidden"  name="<?=$name?>" value="<?=$selected?>"/>
			</td></tr></table>
			<?
			$html = ob_get_contents();
			ob_end_clean(); // Don't send output to client
			}
		else
			{
			ob_start();
			?>
			<table><tr><?=$tag?><td> ---- </td></tr></table>
			<?
			$html = ob_get_contents();
			ob_end_clean(); // Don't send output to client
			}			
		}
		
	else
		{
		$temp = $db->select_input_name($table, $selected, "", "", "_name", $condition );
		ob_start();
    	?>
		<table><tr><?=$tag?><td>
    		<select size="<?=$size?>" name="<?=$name?>" <?=$multiple?>>
			<?=$default?>
	    	<?=$temp?>
    		</select>
    	</td></tr> </table>
 		<?
    	$html = ob_get_contents();
    	ob_end_clean(); // Don't send output to client
		}
	
	return ($html);
}


 ?>
