/* IIP Javascript SlideShow Class
 */
/*can make use of external search variables i.e.
  var pageDetails = {
	"image":{"details":'.$postJSL.', "selected":new Object()},
	"text":{"details":'.$postJSR.', "selected":new Object()}
	}*/
	
//This class can me made to change other values depending on the 
//selected image through the externalFunction
if (typeof externalFunction != "function") {
//if (!window.externalFunction){
	eval ("function externalFunction(detailsPrefix, which, selected, edit)"+
	 "{add2DebugString(\"RUN externalFunction iipgallery.js\");}");}
	
var IIP_Gallery = new Class({

   Extends: IIP,
   initialize: function( main_id, options ) {

    this.source = main_id || alert( 'No element ID given to IIP constructor' );
    this.parent = this.source;
    this.server = options['server'] || '/fcgi-bin/iipsrv.fcgi';
    this.render = options['render'] || 'random';
		//Only used inconjuction with texts.
		this.furtherdetailsEdit = options['furtherdetailsEdit'] || null;
    	
    this.images = new Array(options['image'].length);
    options['image'] || alert( 'Image location not set in IIP constructor options');
    if( $type(options['image']) == 'array' ){
	for( i=0; i<options['image'].length;i++ ){
	    this.images[i] = { src:options['image'][i], sds:"0,90" };
	}
    }
    else this.images = [{ src:options['image'], sds:"0,90"} ];
		
    this.searchSQL = options['searchSQL'] || null;
    
		this.totalims = 0;
		this.totalFullims = 0;
    this.thumbs = 0;
    this.thumbsF = 0;
    this.thumbSize = options['thumbsize'] || 128;
		
		this.fred = 0;
  
    //Is used to define basic details of selected image, starts as 0
    this.selected = 0;

		this.externalVars = options['externalVars'] || null;
		this.furtherdetails =  options['furtherdetails'] || null;
    this.credit = options['credit'] || null;
    this.scale = options['scale'] || null;

    if( options['zoom'] == 0 ) this.initialZoom = 0;
    else this.initialZoom = options['zoom'] || 1;
    
    this.showNavButtons = true;
    if( options['showNavButtons'] == false ) this.showNavButtons = false;

    // If we want to assign a function for a click within the image
    // - used for multispectral curve visualization, for example
    this.targetclick = options['targetclick'] || null;
    
    // Extra Options
    this.centerzoom = options['centerzoom'] || null;
    this.hideNav = options['hideNav'] || null;
    this.hideIcon = options['hideIcon'] || null;
    this.randomstart = options['randomstart'] || null;
    
    this.currentObject;
    this.currentRef;
    // ////////////////////////////////////////////////////////////////////////
    
    this.max_width = 0;
    this.max_height = 0;
    this.min_x = 0;
    this.min_y = 0;
    this.sds = "0,90";
    this.contrast = 1.0;
    this.opacity = 0;
    this.wid = 0;
    this.hei = 0;
    this.rgn_x = 0;
    this.rgn_y = 0;
    this.rgn_w = this.wid;
    this.rgn_h = this.wid;
    this.xfit = 0;
    this.yfit = 0;
    this.navpos = [0,0];
    this.tileSize = [0,0];
    this.num_resolutions = 0;
    this.res;
    this.refresher = null;
		
		this.scrollSpy = null;
		this.scrollSpyDo = true;

    // Number of tiles loaded
    this.nTilesLoaded = 0;
    this.nTilesToLoad = 0;
		
		/* Load us up when the DOM is fully loaded! 
     */
    window.addEvent( 'domready', function(){  this.load() }.bind(this) );
  },

  iipload: function() {
    
  if(this.selected)
    {
    var loc_vals = this.selected;
    
		this.images = new Array(1);
    this.images = [{ src:loc_vals['image'], sds:"0,90"} ];
      
	  this.server = loc_vals['server'];
	    
	  this.max_width = loc_vals['max_width'];
	  this.max_height = loc_vals['max_height'];

	  this.tileSize[0] = loc_vals['tile_size'];
	  this.tileSize[1] = loc_vals['tile_size'];

	  this.num_resolutions = loc_vals['num_resolution'];
	  this.res = this.num_resolutions;
	    
	  // Credit can be dynamically updated if required.
	  if (!this.credit)
	    {this.credit = loc_vals['credit'];}
	    
	  if (this.randomstart && this.randomstart != 'fixedzoom')
	    {
	    if (this.res > 3)
  	  	{this.initialZoom = $random(1, this.res -1);}
			else
  			{this.initialZoom = $random(0, this.res - 1);}
	    }
	    
    this.createWindows();	    
		 
	  if (this.randomstart)
	    {var rx = $random(0, this.wid) - this.rgn_x;
       var ry = $random(0, this.hei) - this.rgn_y;
       this.scrollTo( rx, ry );}
    }     
  },
  
  selectThumbs: function (which) {
    if(this.selected["no"])
      {$(this.source+'_dt_'+this.selected["no"]).removeClass('ttsel');}
    
		if($(this.source+'_dt_'+which))
			{$(this.source+'_dt_'+which).addClass('ttsel');}
    this.selected = this.thumbs[which];
		
		var imDArr = this.thumbs[which];
		updateObjectMenu (this.thumbs[which]["id"], this.parent+'_furtherdetails');
		externalFunction("image", "image", this.thumbs[which]["id"], this.furtherdetailsEdit);
    },
  
  thumbload: function() {		
  
  //Details of larger sets of images can be pulled from databases via ajax
  //FOR EXAMPLE
	
	//var answer = confirm ('Run Search');
	var othis = this;
	
  searchRequest = new Request( 
  	{
  	method: 'post',
  	url: 'exploreAjax.php',
    data: {'searchSQL':this.searchSQL, 'imLimit':25, 'imStart':0},
    encoding:'UTF-8',
  	autoCancel: true, 
  	async:false,  
    onRequest: function() {}, 
  	onFailure: function() {alert('problem')}, 
    onComplete: function(response) {
			var loc_vals = new Array ();
			var more_vals = new Array ();
			var im_count;
			var message;
						
			if (response)
			  {eval ('loc_vals = ' + response);}
				
			if (message)
				{alert (message);
				 externalFunction("image", "image", 0, this.furtherdetailsEdit);}
			else
				{			
				this.thumbs = loc_vals;
      
				var tt = objectSize(this.thumbs);
									
				this.totalims = objectSize(this.thumbs);	
				this.totalFullims = im_count;
			
  			$(this.parent+'_thumbs').setStyles({
    			'width': (this.totalims * (this.thumbSize + 4)) + 2 + 'px'}); 
				//2*1px border + 2px gap + final 2px on right
		
  			//Update of this.thumbs allows for new thumbs to be displayed ..
  			this.refreshThumbs(this.thumbs);	
				this.buildThumbInfo();
				//if (im_count > tt)
				//	{this.buildThumbInfo();}
				//else
				//	{var cs = $(this.parent+'_thumbstrip').getSize();
			   //	$(this.parent+'_thumbstrip').setStyles({'width': cs.x + 96 + 'px'});
			  // 	$(this.parent+'_tinfo').setStyles({'display': 'none'});}
				}
										
    }.bind(this) 			  
  });
	
	searchRequest.send();    
  },
	
	morethumbload: function(climit) {  	
	//Details of larger sets of images can be pulled from databases via ajax
  var start = this.totalims;
	
  searchRequest = new Request( 
  	{
  	method: 'post',
  	url: 'exploreAjax.php',
    data: {'searchSQL':this.searchSQL, 'imLimit':climit, 'imStart':start},
    encoding:'UTF-8',
  	autoCancel: true, 
  	async:false,  
    onRequest: function() {}, 
  	onFailure: function() {alert('problem')}, 
    onComplete: function(response) {
			var loc_vals = new Array ();
			var more_vals = new Array ();
			var im_count;
		
			if (response)
			  {eval ('loc_vals = ' + response);}
			
			var tt = objectSize(this.thumbs);
			var tf = objectSize(loc_vals);
			
			var tleft = (this.thumbSize + 4) * tt;
			this.totalims = this.totalims + tf;
  		$(this.parent+'_thumbs').setStyles({
	  		'width': (this.totalims * (this.thumbSize + 4)) + 2 + 'px'}); 
			//2*1px border + 2px gap + final 2px on right
		
			this.thumbsF = {};
	
			var count = 0;
		
  		for (var key in loc_vals) 
				{   
      	var imd = loc_vals[key];
				this.thumbs[key] = imd;
				var cim = this.makePyrThumb (imd);      
  			$(cim).injectInside($(this.parent+'_thumbs'));
    		$(cim).setStyle("left", tleft + 'px');
	    	tleft = tleft + this.thumbSize + 4; //2*1px border + 2px gap
    		}		
	
		this.buildThumbInfo();
										
    }.bind(this) 			  
  });	
	
	if (climit > 150)
		{var run = confirm ('Loading the last ' + climit + ' images, this may take a few minutes');}
	else
		{var run = true;}
		
	if (run)
		{searchRequest.send();}
  },
	
	buildThumbInfo: function() {
		var tdiv = $(this.parent+'_tinfo');
  	if (tdiv)
    	{tdiv.getChildren().each( function(el) {el.dispose();});}
			
		var tt = this.totalims;// objectSize(this.thumbs);
		var tf = this.totalFullims;
		var dif = tf - tt;
		//var tf = objectSize(this.thumbsF);									 
		//morethumbload: function(climit)
		var divc = divtxt(this.parent+'_ti1', 'tidiv', '', 'thumbinfo', {0:'Displaying', 1:tt+' of ' + (tf), 2:'thumbnails'});
			$(tdiv).appendChild(divc);	
			
		if (dif <= 0)
			{}
		else
			{
			
			/* scrollspy instance */
			if (Browser.Engine.trident)
				{}
			else
				{
			this.scrollSpyDo = false;
    	this.scrollSpy = new ScrollSpy({
        min: 0,
        onEnter: function(position,enters) {},
        onLeave: function(position,leaves) {},
        onTick: function(position,state,enters,leaves) {
					var pP = $(this.parent).getPosition();
					var tB = $(this.parent+'_thumbs').getSize();	
					var tBp = $(this.parent+'_thumbs').getPosition();	
					var tS = $(this.parent+'_thumbstrip').getSize();					
					var tP = $(this.parent+'_thumbstrip').getPosition();
					
					var cX = (pP.x - tP.x);
					var cMax = ((this.thumbSize + 4) * this.totalims) - tS.x;
					var val = cMax - cX;
					var cdif = this.totalFullims - this.totalims;
					if (cdif > 25) {cdif = 25;}						
					
					if (val > tS.x && cdif && !this.scrollSpyDo)
						{add2DebugString ('TRUE:');
						 this.scrollSpyDo = true;}
						 
					//if (this.scrollSpyDo)
					//	{
					//	add2DebugString({"tBp.x":tBp.x, "tB.x":tB.x, "tS.x":tS.x, "pP.x":pP.x, "tP.x":tP.x, "val":val});//tP.x +' : '+pP.x+'   ('+ cMax+' - '+cX + ') < ' + tS.x );
						 //add2DebugString ('ScrollSpy :'+ val + ' < ' + tS.x + '   (' + pP.x +' - '+tP.x + ')   ' + cdif);
					//	}
						 
					if (val < tS.x && cdif && this.scrollSpyDo)
						{//add2DebugString ('FIRE');
						 this.scrollSpyDo = false;
						 this.morethumbload(cdif);
						 this.scrollSpy = null;}
						 						
					//$(this.parent+'_thumbstrip_px').value = cMax+':'+val;
        	}.bind(this),
        container: this.parent+'_thumbstrip',
				mode: 'horizontal'
    		});
			}
		
			
		
			//if (dif < 50)
			//	{//divc = divtxt(this.parent+'_tinfo50', 'tidivB', '', 'thumbinfoMore', {0:'ADD '+dif}); 
				 //$(divc).addEvent('click', function(event){this.morethumbload(dif);}.bind(this));
				 //$(tdiv).appendChild(divc);
			//	 }				 
			//else //(tf > 50)
			//	{
				if (dif < 25 && Browser.Engine.trident)
					{divc = divtxt(this.parent+'_tinfo50', 'tidivB', '', 'thumbinfoMore', {0:'ADD '+dif}); 
				 	 $(divc).addEvent('click', function(event){this.morethumbload(dif);}.bind(this));
				 	 $(tdiv).appendChild(divc);}
				else if (dif > 25 && Browser.Engine.trident)
					{divc = divtxt(this.parent+'_tinfo50', 'tidivB', '', 'thumbinfoMore', {0:'ADD 25'}); 
				 	 $(divc).addEvent('click', function(event){this.morethumbload(25);}.bind(this));
				 	 $(tdiv).appendChild(divc);}
					 
				if (dif > 25)
					{divc = divtxt(this.parent+'_tinfo50', 'tidivB', '', 'thumbinfoMore', {0:'ADD ALL'}); 
				   $(divc).addEvent('click', function(event){this.morethumbload(dif);}.bind(this));
				 	 $(tdiv).appendChild(divc);}
			 //}
				 //}						
			}
		
	 	//var obx = makeInput ('text', this.parent+'_thumbstrip_px', "na", 95, "", 0);
	 	//$(tdiv).appendChild(obx);	
		},
  
	
  refreshThumbs: function() {
    
  var tdiv = $(this.parent+'_thumbs');
  if (tdiv)
    {tdiv.getChildren().each( function(el) {el.dispose();});}
     
  var tleft = 0;
	var no = 0;
	
	
  for (var key in this.thumbs) {   
      
  	var imd = this.thumbs[key];
  	var cim = this.makePyrThumb (imd);      
  	
    cim.injectInside(tdiv);
    $(cim).setStyle("left", tleft + 'px');
    tleft = tleft + this.thumbSize + 4; //2*1px border + 2px gap
    }
  
	  

  if (!this.selected)
    {this.selectThumbs(0);}
 
  this.iipload();
	//this.prepMoreThumbs();
  },
	
  prepMoreThumbs: function(no) 
		{
  	var tt = objectSize(this.thumbs);
		var tf = objectSize(this.thumbsF);
		
		if (!no || (no > tf))
			{no = tf}
			
		if (no > 150)
			{var run = confirm ('Loading the last ' + no + ' images, this may take a few minutes');}
		else
			{var run = true;}
			
		if (run)
			{		
			var tleft = (this.thumbSize + 4) * tt;
 			this.totalims = this.totalims + no;
  
			$(this.parent+'_thumbs').setStyles({
	  		'width': (this.totalims * (this.thumbSize + 4)) + 2 + 'px'}); 
			//2*1px border + 2px gap + final 2px on right
		
			var loc = this.thumbsF;
			this.thumbsF = {};
	
			var count = 0;
		
  		for (var key in loc) 
				{   
      	var imd = loc[key];
			
				if(count < no)
					{this.thumbs[key] = imd;
				 	var cim = this.makePyrThumb (imd);      
  			 	$(cim).injectInside($(this.parent+'_thumbs'));
    		 	$(cim).setStyle("left", tleft + 'px');
	    			tleft = tleft + this.thumbSize + 4; //2*1px border + 2px gap
					}
				else
					{this.thumbsF[key] = imd;}	
				count++;
    		}		
	
		this.buildThumbInfo();
		}
  },
  
  addMoreThumbs: function() {
    
	var winWidth = Window.getWidth();
  var winHeight = Window.getHeight();
		
  var tdiv = $(this.parent+'_thumbs');
     
	var tt = objectSize(this.thumbs);
	var tf = objectSize(this.thumbsF);
		
	var tleft = (this.thumbSize + 4) * tt;
 	this.totalims = this.totalims + tf;
  
	$(this.parent+'_thumbs').setStyles({
  	'width': (this.totalims * (this.thumbSize + 4)) + 2 + 'px'}); 
		//2*1px border + 2px gap + final 2px on right
	
  for (var key in this.thumbsF) {   
      
  	var imd = this.thumbsF[101];
		this.thumbs[key] = imd;
		
  	var cim = this.makePyrThumb (imd);      
  	
    cim.injectInside(tdiv);
    $(cim).setStyle("left", tleft + 'px');
    tleft = tleft + this.thumbSize + 4; //2*1px border + 2px gap
    }		
	
	//$(this.parent+'_cover').setStyles({
  //	'display': 'none'});
  },
  


  load: function(){
   
  var sD = $(this.source).getSize();
	var sW = sD.x, sH = sD.y;
	
	var tsH = this.thumbSize + 48;
	var ttH = this.thumbSize + 28;
	var iipH = sH - tsH - 1;
	
	if (iipH < 256)
	  {iipH = 256;}
	if (sW < 256)
	  {sW = 256;}
	  
	var tT = iipH + 1;// - 4;
	
	var stripW = sW * 2;
	var stripL = (sW/2) - (this.thumbSize/2) - 3;//2px margin + 1px border
	
  $(this.source).setStyles({
    'overflow': 'auto'});	
  
	if (this.furtherdetails)
		{
		var fdH = 24;//150;
		iipH = iipH - fdH - 4;
		if (iipH < 256) {iipH = 256;}
		tT = iipH + 1;
		
		new Element('div', {
    'id': this.source+'_furtherdetails', 'class': 'floatframeB'
	  }).injectInside($(this.source));	
  
  	$(this.source+'_furtherdetails').setStyles({
    	'height': fdH + 'px', width: sW + 'px', 
    	'top': iipH + 1 - 4 +'px', 'left': '0px',
    	'borders': '0px solid white'});}
					
  new Element('div', {
    'id': this.source+'_iip', 'class': 'targetframe'
	  }).injectInside($(this.source));	
  
  $(this.source+'_iip').setStyles({
    'height': iipH + 'px', width: sW + 'px', 
    'top': '0px', 'left': '0px',
    'borders': '0px solid white'});	  
	  
  new Element('div', {
    'id': this.source+'_thumbstrip', 'class': 'thumblineSL'
	  }).injectInside($(this.source));	
  
  $(this.source+'_thumbstrip').setStyles({
    'height': tsH + 'px', 'width': sW - 96 + 'px',
    'top': tT -2 + 24 +'px', 'left': +'0px'});
		
  new Element('div', {
    'id': this.source+'_tinfo', 'class': 'tinfo'
	  }).injectInside($(this.source));	
		
  $(this.source+'_tinfo').setStyles({
    'height': tsH + 'px', 'width': 96 + 'px',
    'top': tT -2 + 24 +'px', 'right': +'10px'});
	    
  new Element('div', {
    'id': this.source+'_thumbs', 'class': 'thumbstripSL'
	  }).injectInside($(this.source+'_thumbstrip'));	    		
  
  $(this.source+'_thumbs').setStyles({
    'height': ttH + 'px', 'width': stripW + 'px',
    'top': '0px', 'left': 0 +'px'});
		
	this.myMorph = new Fx.Morph(this.source+'_thumbs');	
  
  new Element('div', {
    'id': this.source+'_con',
    'class': 'con'
	  }).injectInside($(this.source));
	
  new Element('div', {
	  'id': this.source+'_currentDetails',
	  'class': 'currentDetails'
	  }).injectInside($(this.source));

  new Element('div', {
	  'id': this.source+'_cover',
	  'class': 'cover'
	  }).injectInside($(this.source));
  	  
  this.source = this.source+'_iip';
 
  this.thumbload();
  }, 
      
  imNext: function(Dbl) 
    {
    var cp = $(this.parent+'_thumbs').getPosition($(this.parent+'_thumbstrip')); 
    var cs = $(this.parent+'_thumbstrip').getSize();
		
		if (Dbl)
			{var js = Math.round(cs.x / (this.thumbSize - 4));}
		else
			{var js = 1;}
			
    var stripL = cp.x - (this.thumbSize * js) - (4 * js);
		var test = (cs.x/2) - (this.totalims * (this.thumbSize + 4)) + 2 + (this.thumbSize/2); 
		
		if (stripL >= test)
			{this.myMorph.start({left: stripL +'px'});}
		else 
			{this.myMorph.start(this.myMorph.start(
			{left: test +'px',
			 'background-color': ['#603c45', '#383c45']}));}
	  }, 
      
  imPrevious: function(Dbl) 
    {
    var cp = $(this.parent+'_thumbs').getPosition($(this.parent+'_thumbstrip'));
    var cs = $(this.parent+'_thumbstrip').getSize();
    
		if (Dbl)
			{var js = Math.round(cs.x / (this.thumbSize - 4));}
		else
			{var js = 1;}
			
		var stripL = cp.x + (this.thumbSize * js) + (4 * js);
		var test = (cs.x/2) - (this.thumbSize/2) - 3 + 1;
			//(2px margin + 1px border) addition of final 1 to deal with rounding
		
		if (stripL <= test)
		{this.myMorph.start({left: stripL +'px'});
		}
		else {this.myMorph.start(this.myMorph.start(
			{left: test +'px',
			 'background-color': ['#603c45', '#383c45']}));}
	  },
	    
  refreshDetails: function()
	  {	
	  $(this.source+'_currentDetails').getChildren().each( function(el) 
	    {el.dispose();});

    if (this.currentObject)
      {
	    var tft = new Element("font", {'class': 'h3'});    
      var tftv = document.createTextNode(this.currentObject);
  	  tft.appendChild(tftv);
  	  $(this.source+'_currentDetails').appendChild(tft);
      }
    if (this.currentRef && this.currentObject)
      { 
  	  tft = new Element("br");  
  	  $(this.source+'_currentDetails').appendChild(tft); 
  	  tft = new Element("br");  
  	  $(this.source+'_currentDetails').appendChild(tft); 
      }
    if (this.currentRef)
      {
  	  tft = new Element("font", {'class': 'h3'});    
      tftv = document.createTextNode(''+this.currentRef);
	    tft.appendChild(tftv);
	    $(this.source+'_currentDetails').appendChild(tft);
      }
    },

  makePyrThumb: function (imArr, nothumb)
  	{	
    var thisDiv = new Element("div", {
      'class': 'tt'
      }); 
      
  	$(thisDiv).setAttribute("id", this.source+'_dt_'+imArr['no']);
    $(thisDiv).setStyle("height", this.thumbSize + 'px');
    $(thisDiv).setStyle("width", this.thumbSize + 'px');
  
  	//{'id':1, 'max_width':6000, 'max_height':4362, 'tile_size':256, 
    //  'num_resolution':6, 'image':'/pics/tmp/websiteimages/Website_Collection_Online/Web Zoom Images/WZ web NG Fronts/N-1234-00-000027-WZ-PYR.tif',
    //  'server':'/fcgi-bin/iipsrv.fcgi'}
    
  	var thisImg = document.createElement("img");
		var lim = this.thumbSize - 2;
		
	  if ((imArr['max_width']*1) > (imArr['max_height']*1))
	    {var width = lim;
  	   var height = (lim * imArr['max_height'])/imArr['max_width'];
			 }
    else
	    {var width = (lim * imArr['max_width'])/imArr['max_height'];
	     var height = lim;
			 }
	   
    $(thisImg).setStyle("height", 'auto');
    $(thisImg).setStyle("width", width + 'px');
    
		var src = imArr['server']+"?FIF="+imArr['image']+
			"&SDS=0,90&CNT=1.0&WID="+lim+"&QLT=75&CVT=jpeg";
		
		$(thisImg).setAttribute("src", src);
	  $(thisImg).setAttribute("alt", 'Image '+imArr['id']);
	
	  $(thisImg).setAttribute("id", this.source+'_thumb_'+imArr['no']);
	  $(thisImg).setAttribute("name", this.source+'_thumb_'+imArr['no']);
	  $(thisImg).setStyle('cursor', 'pointer');
				
    $(thisDiv).addEvent('click', function(event){
			var cim = event.target;
			if (cim.tagName == "IMG")
				{var cdiv = cim.parentNode;}
			else
				{var cdiv = cim;}
    
			var cs = $(this.parent+'_thumbstrip').getSize();
			var crp = $(cdiv).getPosition($(this.parent+'_thumbstrip'));
			
			var tp = (cs.x/2) - (this.thumbSize/2) - 3;//2px margin + 1px border
			var dif = crp.x - tp - 2;//2 is for the margin
			
			var cstp = $(this.parent+'_thumbs').getPosition($(this.parent+'_thumbstrip'));
			var npos = cstp.x - dif//;- (this.thumbSize/2);// - 98;
			
			this.updateIIP (imArr);
			//this.myMorph.start({left: npos + 'px'});
			}.bind(this));

    $(thisDiv).appendChild(thisImg);   
		
		var ft = new Element("p", {
    	'class': 'thumb'
    	});

		var strl = imArr['filename'].length;
		if (strl > 20)
			{var disp = imArr['filename'].substring(0,16) + ' ...';}
		else
			{var disp = imArr['filename'];} 
			
		var ftv = document.createTextNode(disp);
    $(ft).setStyle("top", this.thumbSize + 'px');
		$(ft).appendChild(ftv);
		$(thisDiv).appendChild(ft);
	  
	  return (thisDiv);
	  },
	  
	 updateIIP: function (imArr)
    {
    if ($(this.source))
      {$(this.source).getChildren().each( function(el) {el.dispose();});}
     
    //this.selected = imArr;
    this.selectThumbs(imArr["no"]);
		this.iipload();
    }
	
});
  
function objectSize (obj) {
  var size = 0, key;
  
	for (key in obj) {
    if (obj.hasOwnProperty(key)) size++;
    }
		
  return size;
	}


function str_repeat(str, repeat) 
  {
  var output = '';
  for (var i = 0; i < repeat; i++) {
    output += str;}

  return output;
  }
	
var MAX_DEPTH = 10;	
function print_r(obj, indent, depth) {

  var ws = '    ';
  var output = '';

  indent = (!indent) ? 0 : indent;
  depth = (!depth) ? 0 : depth;

  if (depth > MAX_DEPTH) {
    return str_repeat(ws, indent) + '*Maximum Depth Reached*\n'; }

  if (typeof(obj) == "object") {
    output += (indent == 0) ? typeof(obj) + '\n(\n' : '';
    indent++;

    var child = '';

    for (var key in obj) {
      try {child = obj[key];}

      catch (e) {child = '*Unable To Evaluate*';}

      output += str_repeat(ws, indent) + '['+key+'] => ';
      
      if (typeof(child) == "object") 
        {
        indent++;
        output += typeof(child) + '\n';
        output += str_repeat(ws, indent) + '(\n';
        output += print_r(child, indent, depth+1);
        output += str_repeat(ws, indent) + ')\n';
        indent--;
        }
      else 
        {output += child + '\n';}
      }

    indent--;
    output += (indent == 0) ? ')\n' : '';
    return output;
    }
  else {return str_repeat(ws, indent) + obj + '\n';}
}

function divtxt(id, cls, tid, tcls, txt) 
	{ 
  var ndiv = new Element('div', {'id': id, 'class': cls});
	
	for (var key in txt) {      
		var ft = new Element("font", {'id': tid, 'class': tcls});
		var ftv = document.createTextNode(txt[key]);
			$(ft).appendChild(ftv);
			$(ndiv).appendChild(ft);
		var br = new Element("br");
			$(ndiv).appendChild(br);
		}
						
	return (ndiv);
	}


function buildIIPGallerySearch (parentDiv, imDiv, searchDiv, vars)
	{
  var sD = $(parentDiv).getSize();
	var sW = sD.x, sH = sD.y;
	  
	var th = 80;
		
	var imH = sH - th - 200;
	if (imH < 250)
		{imH = 250;}
	
	//Build Search Div
  $('furtherDetails').setStyles({
    'height': 200 + 'px', 
    'top': th + imH + 'px', 'left': '0px'});	
		
	//Build Search Div
  $(searchDiv).setStyles({
    'height': th + 'px', 
    'top': '0px', 'left': '0px'});	
		
	var opts = {"image":"Image Details", "object":"Object Details", "keyword":"Category"};
	var limStr = "";//arrToString (vars);
	//var post = {"searchObjects":{"0":"ng168"},"searchImages":{},"searchCategories":{"0":"vis"},"searchTexts":{"0":"vis"},"displayOption":"1"};
	
	for (var key in vars) 
		{
		for (var key2 in vars[key])
			{
			var locStr = "";
			
			if (key == "searchObjects")
			 {locStr = "Object:'"+vars[key][key2]+"'";}
			else if (key == "searchImages")
			 {locStr += "Image:'"+vars[key][key2]+"'";}
			else if (key == "searchCategories")
			 {locStr += "Category:'"+vars[key][key2]+"'";}
			 
			if (locStr)
				{if (limStr) {limStr = limStr + ", " + locStr;}
				 else {limStr = locStr;}}
			}			
		}
			
	var ob1 = buildFont ('Search Images: ', '', 'ptitle3', ''); 
	var ob2 = array2dropdown ("imlimitby", opts, 0, "", ""); 
	var ob3 = makeInput ('text', "imkeysearch", "enter value", 150, "", 0); 
	$(ob3).addEvent('focus', function(event){
		if (document.getElementById('imkeysearch').value == 'enter value')
			{document.getElementById('imkeysearch').value='';}});
	$(ob3).addEvent('keydown', function(event){
		if (event.key == "enter")
			{$('imgosearch').fireEvent('click', $('imgosearch'), 1);}
		});
	
	var ob4 = makeInput ('button', "imgosearch", "Go", 30, "", 0); 	
	$(ob4).addEvent('click', function(event){
 		var tcell = $(this).parentNode;
		var tinp = $(tcell).previousSibling.firstChild;		
		var tsel = $(tcell).previousSibling.previousSibling.firstChild;		
		
		if (tsel.value == "object")
			{var newArr = {"searchObjects":{"0":tinp.value}};}
		else if (tsel.value == "image")
			{var newArr = {"searchImages":{"0":tinp.value}};}
		else //if (tsel.value == "keyword")
			{var newArr = {"searchCategories":{"0":tinp.value}};}
		
		array2hidden ('pageVars', post);
		array2hidden ('pageVars', newArr);
		
		newArr = {"test":"ok"};
		array2hidden ('pageVars', newArr);
		
		document.pageVars.submit();		
  });
	
	var ob5 = makeInput ('button', "cisearch", "Clear Search", 15, "", 0);
	var ob6 = buildFont ('Images Limited by: ', '', 'cls', ''); 
	var ob7 = buildFont ('', limStr, 'cls', ''); 
	
  var cells = new Array;  
  var rows = new Array;
	
	cells[0] = buildCell (ob1, '10px', 'nowrap', 1, 1);
	cells[1] = buildCell (ob2, '10px', 'nowrap', 1, 1);
	cells[2] = buildCell (ob3, '10px', 'nowrap', 1, 1);
	cells[3] = buildCell (ob4, '', '', 1, 1);
	rows[0] = buildRow (cells);
  cells = new Array;
	cells[0] = buildCell (ob6, '10px', 'nowrap', 1, 1);
	cells[1] = buildCell (ob7, '10px', '', 3, 1);
	rows[1] = buildRow (cells);
	
  var tb = buildTable(rows, "imSearchTable");
  	tb.setAttribute("cellpadding", '5px');
  //tb.setAttribute("id", 'imageTable_'+thisVals["id"]);
  //tb.setAttribute("border", '1px');
  $(searchDiv).appendChild(tb);		
		
	//Build IIP Gallery	
		
  $(imDiv).setStyles({
    'height': imH + 'px', 
    'top': th + 'px', 'left': '0px'});	 		
	
  im1 = new IIP_Gallery( imDiv, {
  	image: 'blank',
  	searchSQL: vars,
  	zoom: 1,
  	centerzoom: 1,
  	render: 'random',
  	hideNav: false,
  	hideIcon: false
  	}); 
	}
	
	
//buildTextSearch ("pageright", "txtRight", "searchTexts", post);
function buildTextSearch (parentDiv, txtList, searchDiv, vars)
	{
	/*
<div id="pageright" class="pageright">
	<div class="searchframe" id="searchTexts"></div>
	<div class="targetframe" id="txtRight"></div>
	<div class="" id="TextDetails"></div>
	<div class="" id="TextFurtherDetails"></div>
</div>
*/
  var sD = $(parentDiv).getSize();
	var sW = sD.x, sH = sD.y;
	  
	var th = 80;
		
	var txtH = sH - th - 400;
	if (txtH < 250)
		{txtH = 250;}
	
	//Build Search Div
  $(searchDiv).setStyles({
    'height': th + 'px', 
    'top': '0px', 'left': '0px'});	
		
	$('txtRight').setStyles({
    'height': txtH + 'px', 
		'background': 'blue', 
    'top': th + 'px', 'left': '0px'});	
		
  $('TextDetails').setStyles({
    'height': 200 + 'px', 
		'background': 'yellow', 
    'top': th + txtH + 'px', 'left': '0px'});	
		
  $('TextFurtherDetails').setStyles({
    'height': 200 + 'px',
		'background': 'red',  
    'top': th + 200 + txtH + 'px', 'left': '0px'});	
				
	var opts = {"text":"Text Details", "object":"Object Details", "keyword":"Category"};
	//alert(vars);
	var limStr = "";//arrToString (vars);
	//var post = {"searchObjects":{"0":"ng168"},"searchImages":{},"searchCategories":{"0":"vis"},"searchTexts":{"0":"vis"},"displayOption":"1"};
	
	for (var key in vars) 
		{
		for (var key2 in vars[key])
			{
			var locStr = "";
			
			if (key == "searchObjects")
			 {locStr = "Object:'"+vars[key][key2]+"'";}
			else if (key == "searchImages")
			 {locStr += "Text:'"+vars[key][key2]+"'";}
			else if (key == "searchCategories")
			 {locStr += "Category:'"+vars[key][key2]+"'";}
			 
			if (locStr)
				{if (limStr) {limStr = limStr + ", " + locStr;}
				 else {limStr = locStr;}}
			}			
		}
			
	var ob1 = buildFont ('Search Texts: ', '', 'ptitle3', ''); 
	var ob2 = array2dropdown ("txtlimitby", opts, 0, "", ""); 
	var ob3 = makeInput ('text', "txtkeysearch", "enter value", 150, "", 0); 
	$(ob3).addEvent('focus', function(event){
		if (document.getElementById('txtkeysearch').value == 'enter value')
			{document.getElementById('txtkeysearch').value='';}});
	$(ob3).addEvent('keydown', function(event){
		if (event.key == "enter")
			{$('txtgosearch').fireEvent('click', $('txtgosearch'), 1);}
		});
	
	var ob4 = makeInput ('button', "txtgosearch", "Go", 30, "", 0); 	
	$(ob4).addEvent('click', function(event){
 		var tcell = $(this).parentNode;
		var tinp = $(tcell).previousSibling.firstChild;		
		var tsel = $(tcell).previousSibling.previousSibling.firstChild;		
		
		if (tsel.value == "object")
			{var newArr = {"searchObjects":{"0":tinp.value}};}
		else if (tsel.value == "text")
			{var newArr = {"searchTexts":{"0":tinp.value}};}
		else //if (tsel.value == "keyword")
			{var newArr = {"searchCategories":{"0":tinp.value}};}
		
		array2hidden ('pageVars', post);
		array2hidden ('pageVars', newArr);
		
		newArr = {"test":"ok"};
		array2hidden ('pageVars', newArr);
		
		document.pageVars.submit();		
  });
	
	var ob5 = makeInput ('button', "cisearch", "Clear Search", 15, "", 0);
	var ob6 = buildFont ('Texts Limited by: ', '', 'cls', ''); 
	var ob7 = buildFont ('', limStr, 'cls', ''); 
	
  var cells = new Array;  
  var rows = new Array;
	
	cells[0] = buildCell (ob1, '10px', 'nowrap', 1, 1);
	cells[1] = buildCell (ob2, '10px', 'nowrap', 1, 1);
	cells[2] = buildCell (ob3, '10px', 'nowrap', 1, 1);
	cells[3] = buildCell (ob4, '', '', 1, 1);
	rows[0] = buildRow (cells);
  cells = new Array;
	cells[0] = buildCell (ob6, '10px', 'nowrap', 1, 1);
	cells[1] = buildCell (ob7, '10px', '', 3, 1);
	rows[1] = buildRow (cells);
	
  var tb = buildTable(rows, "txtSearchTable");
  	tb.setAttribute("cellpadding", '5px');
  //tb.setAttribute("id", 'imageTable_'+thisVals["id"]);
  //tb.setAttribute("border", '1px');
  $(searchDiv).appendChild(tb);		
		
	//Build IIP Gallery	
		
   		
	}

/*
	Class:    	ScrollSpy
	Author:   	David Walsh
	Website:    http://davidwalsh.name/js/scrollspy
	Version:  	1.0.0
	Date:     	5/19/2009
	Built For:  MooTools 1.2.2
*/

/* scroll spy plugin / class */
var ScrollSpy = new Class({
	
	/* implements */
	Implements: [Options,Events],

	/* options */
	options: {
		min: 0,
		mode: 'vertical',
		max: 0,
		container: window,
		onEnter: $empty,
		onLeave: $empty,
		onTick: $empty
	},
	
	/* initialization */
	initialize: function(options) {
		/* set options */
		this.setOptions(options);
		this.container = $(this.options.container);
		this.enters = this.leaves = 0;
		this.max = this.options.max;
		
		/* fix max */
		if(this.max == 0) 
		{ 
			var ss = this.container.getScrollSize();
			this.max = this.options.mode == 'vertical' ? ss.y : ss.x;
		}
		/* make it happen */
		this.addListener();
	},
	
	/* a method that does whatever you want */
	addListener: function() {
		/* state trackers */
		this.inside = false;
		this.container.addEvent('scroll',function() {
			/* if it has reached the level */
			var position = this.container.getScroll();
			var xy = this.options.mode == 'vertical' ? position.y : position.x;
			/* if we reach the minimum and are still below the max... */
			if(xy >= this.options.min && xy <= this.max) {
					/* trigger Enter event if necessary */
					if(!this.inside) {
						/* record as inside */
						this.inside = true;
						this.enters++;
						/* fire enter event */
						this.fireEvent('enter',[position,this.enters]);
					}
					/* trigger the "tick", always */
					this.fireEvent('tick',[position,this.inside,this.enters,this.leaves]);
			}
			else {
				/* trigger leave */
				if(this.inside) 
				{
					this.inside = false;
					this.leaves++;
					this.fireEvent('leave',[position,this.leaves]);
				}
			}
		}.bind(this));
	}
});
