<?php
 		
require_once( "header.php" );
	
$comment = "<h2>Sorry you do not have permission to access this page".
  			 	 "<br>If you think there has been an error please ".
			 		 "contact<br>joseph.padfield@ng-london.org.uk</h2>";
			 
$un = "raphael";//$_SERVER['PHP_AUTH_USER'];
$pw = "zaq12wsx";//$_SERVER['PHP_AUTH_PW'];

//print_r ($_POST);
$base = "http://rdf.ng-london.org.uk/2010/7/rrr_v0.4.owl";
			 
if (!$un) 
 	{
 	header('WWW-Authenticate: Basic realm="The Raphael Project: Data Editing Page"');
 	header('HTTP/1.0 401 Unauthorized');
	echo noPremission();	
 	exit;
	}
elseif (!($un == "raphael") || !($pw == "zaq12wsx"))
 	{
	unset ($_SERVER['PHP_AUTH_USER']);
 	header('WWW-Authenticate: Basic realm="The Raphael Project: Data Editing Page"');
 	header('HTTP/1.0 401 Unauthorized');
	echo noPremission();
  exit;
	}
else 
 	{
	setGlobals();
	header('Content-type: text/xml; Charset=utf-8');
	
	if ($_GET["update"])
		{$doUpdate = true;}
	else
		{$doUpdate = false;}
			
	$prp = listProperty($doUpdate);
	$cls = listClass($doUpdate);
	echo fullPage($prp, $cls);
	}	

function updateClass ($tid, $uri)
	{
	$my_db = new DB( $GLOBALS["whichdb"] ); 
	$upQuery = "UPDATE `type` SET ".
    " `type_uri` = '".$uri."' ".
    "WHERE `type_id` = $tid";
		
	$my_db->query( $upQuery ); 
	}
	
function updateProp ($pid, $uri, $inv="")
	{
	$my_db = new DB( $GLOBALS["whichdb"] ); 
	$upQuery = "UPDATE `property` SET ".
    " `property_uri` = '".$uri."' ";
		
	if ($inv)
		{$upQuery = $upQuery." WHERE `property_rev` = $pid";}
	else
		{$upQuery = $upQuery." WHERE `property_id` = $pid";}
		
	$my_db->query( $upQuery ); 		
	}
	
function listClass ($update=false)
	{
	$my_db = new DB( $GLOBALS["whichdb"] ); 
	
	$class_sql = "
	SELECT  `type`.`type_id` as tid, `type`.`type_name` as type,  `type`.`parent_id` AS pid,  `par`.`type_name` AS parent
	FROM type
	LEFT JOIN `type` as par ON `par`.`type_id` = `type`.`parent_id`
	WHERE `type`.`type_id` != 57 
	";
	
	$my_db->query( $class_sql );
 
	ob_start();
		
	echo <<<END
	
	
    <!-- 
    ///////////////////////////////////////////////////////////////////////////////////////
    //
    // Classes
    //
    ///////////////////////////////////////////////////////////////////////////////////////
     -->
		 
    <owl:Class rdf:about="RC57.RRR_Entity">
      <rdfs:label xml:lang="en">RRR Entity</rdfs:label>
      <rdfs:subClassOf>
        <rdf:Description rdf:about="http://www.w3.org/2002/07/owl#Thing">
          <rdfs:comment rdf:datatype="http://www.w3.org/2001/XMLSchema#string">
          </rdfs:comment>
        </rdf:Description>
      </rdfs:subClassOf>
      <rdfs:subClassOf>
      <owl:Restriction>
        <owl:onProperty>
          <owl:DatatypeProperty rdf:ID="RP17.has_identifier"/>
        </owl:onProperty>
        <owl:maxCardinality rdf:datatype="http://www.w3.org/2001/XMLSchema#int"
        >1</owl:maxCardinality>
      </owl:Restriction>
    </rdfs:subClassOf>
    <rdfs:comment rdf:datatype="http://www.w3.org/2001/XMLSchema#string"
    >This class comprises all things in the universe of discourse of the Raphael Research Resource Model.</rdfs:comment>
    </owl:Class>
		
    <owl:Class rdf:about="RCB.RRR_Blank">
		    <rdfs:label xml:lang="en">RRR Blank</rdfs:label>
      <rdfs:subClassOf>
        <rdf:Description rdf:about="http://www.w3.org/2002/07/owl#Thing">
          <rdfs:comment rdf:datatype="http://www.w3.org/2001/XMLSchema#string">
          </rdfs:comment>
        </rdf:Description>
      </rdfs:subClassOf>
			<rdfs:comment rdf:datatype="http://www.w3.org/2001/XMLSchema#string"
    >This class is a debug class to be used to catch errors where properties have been applied but lead to nothing.  This will be removed once the full mapping process is over.</rdfs:comment>
    </owl:Class>

END;

	if ($update)
		{updateClass (57, "RC57.RRR_Entity");}
	
	$insts = array();
	//All values under controlled list
	$cls = getTypeAllChildren (72, "", "", "", false);
		
	//All project categories 
	$pcats = getTypeAllChildren (180, "", "", "", false);
		
	//Controlled lists that should stay as classes that are not directly under 72
	$clcats = array (72, 277, 79, 81, 82, 83, 84, );
	$excl = array_merge ($pcats, $clcats);
		
	while ($myrow = $my_db->next())
	  {
		foreach ($myrow as $key => $value) 
			{$$key = $value;}
								
		$parentB = uriPrep ($parent, $pid, "RC");			
		$typeB =  uriPrep ($type, $tid, "RC");
		$type = ereg_replace ("[&]", "&amp;", $type);	
						
		if (in_array ($tid, $pcats) and $tid != 180 ) //Project Cats instances as well as class
			{$insts[] = array ($type, $typeB, "RC180.Project_Categories");}
				
		if (in_array ($tid, $cls) and $pid != 72 and !in_array ($tid, $excl) ) //Controlled list instances
			{$insts[] = array ($type, $typeB, $parentB);}
		else
			{
			if ($update)
				{updateClass ($tid, $typeB);}
			
			echo <<<END
	 
    <owl:Class rdf:about="$typeB">
        <rdfs:label  rdf:datatype="http://www.w3.org/2001/XMLSchema#string" 
          xml:lang="en">$type</rdfs:label>
        <rdfs:subClassOf>
          <rdf:Description rdf:about="$parentB"></rdf:Description>
        </rdfs:subClassOf>        
    </owl:Class>
END;
			}
		
		}
		
	//Class Instances captured and displayed with other instances
		/*		
	echo <<<END
	
	
    <!-- 
    ///////////////////////////////////////////////////////////////////////////////////////
    //
    // Individuals
    //
    ///////////////////////////////////////////////////////////////////////////////////////
     -->

END;
		
	foreach ($insts as $key => $arr)
		{	
		//$arr = array ($type, $typeB, $parentB)
		$arr[1] = ereg_replace ("RC", "RCL", $arr[1]);
		
		if ($arr[1] == "RCL243.8" or $arr[1] == "RCL244.16")
			{$arr[0] = $arr[0]."-bit";
			 $arr[1] = $arr[1]."-bit";}
			 
		echo <<<END
		
    <!-- http://rdf.ng-london.org.uk/2009/11/rrr_org.owl#$arr[1] -->

    <$arr[2] rdf:about="#$arr[1]">
        <rdfs:label rdf:datatype="http://www.w3.org/2001/XMLSchema#string" 
          xml:lang="en">$arr[0]</rdfs:label>
    </$arr[2]>
	
    
END;
		}*/
			
	$html = ob_get_contents();
	ob_end_clean(); // Don't send output to client
	
	return ($html);	
	}
	
	
function listProperty ($update="")
	{
	$my_db = new DB( $GLOBALS["whichdb"] ); 
	
	$prop_sql = "SELECT 
`property`.`property_id` AS pi, 
`property`.`property_name` as pn, 
`dt`.`type_name` AS domain, 
`rt`.`type_name` AS range, 
`dt`.`type_id` AS did, 
`rt`.`type_id` AS rid,
`property`.`property_rev` AS pir, 
`rev`.`property_name` as prn  
FROM `property` 
LEFT JOIN `property` as rev ON `property`.`property_rev` = `rev`.`property_id`
LEFT JOIN `typeProperty` ON `typeProperty`.`property_id` = `property`.`property_id`
LEFT JOIN `type` AS `dt` ON `typeProperty`.`type_id` = `dt`.`type_id`
LEFT JOIN `type` AS `rt` ON `typeProperty`.`range_id` = `rt`.`type_id`
WHERE 1
ORDER BY `property`.`property_id` ASC
	";
	
	$my_db->query( $prop_sql );
  $prs = array();
	$out = array();
	$doms = array();
	$rans = array();
	
	ob_start();
	
	echo <<<END
	
	
    <!-- 
    ///////////////////////////////////////////////////////////////////////////////////////
    //
    // Data properties
    //
    ///////////////////////////////////////////////////////////////////////////////////////
     -->

END;
	$dprops = ob_get_contents();
	ob_end_clean(); // Don't send output to client
	   
	ob_start();
	
	echo <<<END
	
	
    <!-- 
    ///////////////////////////////////////////////////////////////////////////////////////
    //
    // Object Properties
    //
    ///////////////////////////////////////////////////////////////////////////////////////
     -->

END;

	while ($myrow = $my_db->next())
	  {		
		foreach ($myrow as $key => $value) 
			{$$key = $value;}
		
		$prs[] = $pir;
		
		if (in_array($pi, $prs))
			{}
		else
			{
			$out[$pi] = array ($pi, $pn, $prn, $pir);
			
			$nd = uriPrep ($domain, $did, "RC");
			$nr = uriPrep ($range, $rid, "RC");
			
			if ($doms[$pi])
				{$doms[$pi][$nd] = $nd;}
			else
				{$doms[$pi] = array($nd => $nd);} 
				
			if ($rans[$pi])
				{$rans[$pi][$nr] = $nr;}
			else
				{$rans[$pi] = array($nr => $nr);} 
			}	
		}
		
	$p = 1;
	
	$dom_col_no = 0;
	
	foreach ($out as $key => $arr) 
		{
		$pi = $arr[0];
		
		$pn = uriPrep ($arr[1], $arr[0], "RP");
		$rpn = uriPrep ($arr[2], $arr[0], "RP", "I");
		
		if ($update)
			{updateProp ($pi, $pn, false);
			 updateProp ($pi, $rpn, true);}
		
		// These properties lead to labels or descriptions 
		// May need to create instances later but here just make then values
		if (in_array($pi, array(17, 56, 25, 26, 31, 34, 237, 59, 60)))
			{$rans[$pi] = array ("RC62.Value");}
			
		//Data Properties
		if (in_array("RC62.Value", $rans[$pi]))
			{$dprops .= outProp ($pn, "", $arr[1], $doms[$pi], $rans[$pi]);}
		else // Object properties
			{echo outProp ($pn, $rpn, $arr[1], $doms[$pi], $rans[$pi]);
			 echo outProp ($rpn, $pn, $arr[2], $rans[$pi], $doms[$pi]);}			
		}

	echo $dprops;
	
	$html = ob_get_contents();
	ob_end_clean(); // Don't send output to client
	
	return ($html);
	}
	
function outProp ($pn, $rpn, $lab, $dom, $ran)
	{
	ob_start();	

	if (in_array("RC62.Value", $ran))
		{$pt = "DatatypeProperty";
     $dt = true;}
	else
		{$pt = "ObjectProperty";
     $dt = false;}

	echo <<<END
    <owl:$pt rdf:about="$pn">
        <rdfs:label rdf:datatype="http://www.w3.org/2001/XMLSchema#string" 
				  xml:lang="en">$lab</rdfs:label>
END;

	echo domran ($dom, "domain");

	if ($dt)
		{
    echo <<<END
			<rdfs:range rdf:resource="http://www.w3.org/2001/XMLSchema#string"/>
    </owl:$pt>
END;
		}
	else
		{
		if ($rpn)
			{$extra = "<owl:inverseOf rdf:resource=\"$rpn\"/>";}
		else
			{$extra = "";}
			
		echo domran ($ran, "range");
    echo <<<END
			$extra
    </owl:$pt>
END;
		}

	$str = ob_get_contents();
	ob_end_clean(); // Don't send output to client

	return ($str);
	}

function domran ($arr, $which)
	{
	ob_start();	
	//Multiple Values
	if (count ($arr) > 1)
		{
		echo <<<END
				<rdfs:$which>
          <owl:Class>
            <owl:unionOf rdf:parseType="Collection">
END;
		foreach ($arr as $key => $value) 
			{
			echo <<<END
							<rdf:Description rdf:about="$value"/>
END;
			}
		echo <<<END
						</owl:unionOf>
          </owl:Class>
        </rdfs:$which>
END;
		}
	else
		{
		$value = array_pop($arr);
		echo <<<END
				<rdfs:$which rdf:resource="$value"/>
END;
		}

	$lstr = ob_get_contents();
	ob_end_clean(); // Don't send output to client

	return ($lstr);
	}	
	
	/*	
function listPropertyB ($update="")
	{
	$my_db = new DB( $GLOBALS["whichdb"] ); 
	
	$prop_sql = "SELECT 
`property`.`property_id` AS pi, 
`property`.`property_name` as pn, 
`dt`.`type_name` AS domain, 
`rt`.`type_name` AS range, 
`dt`.`type_id` AS did, 
`rt`.`type_id` AS rid,
`property`.`property_rev` AS pir, 
`rev`.`property_name` as prn  
FROM `property` 
LEFT JOIN `property` as rev ON `property`.`property_rev` = `rev`.`property_id`
LEFT JOIN `typeProperty` ON `typeProperty`.`property_id` = `property`.`property_id`
LEFT JOIN `type` AS `dt` ON `typeProperty`.`type_id` = `dt`.`type_id`
LEFT JOIN `type` AS `rt` ON `typeProperty`.`range_id` = `rt`.`type_id`
WHERE 1
ORDER BY `property`.`property_id` ASC
	";
	
	$my_db->query( $prop_sql );
  $prs = array();
	$out = array();
	$doms = array();
	$rans = array();
	
	ob_start();
	
	echo <<<END
	
	
    <!-- 
    ///////////////////////////////////////////////////////////////////////////////////////
    //
    // Data properties
    //
    ///////////////////////////////////////////////////////////////////////////////////////
     -->

END;
	$dprops = ob_get_contents();
	ob_end_clean(); // Don't send output to client
	   
	ob_start();
	
	echo <<<END
	
	
    <!-- 
    ///////////////////////////////////////////////////////////////////////////////////////
    //
    // Object Properties
    //
    ///////////////////////////////////////////////////////////////////////////////////////
     -->

END;

	while ($myrow = $my_db->next())
	  {		
		foreach ($myrow as $key => $value) 
			{$$key = $value;}
		
		$prs[] = $pir;
		
		if (in_array($pi, $prs))
			{}
		else
			{
			$out[$pi] = array ($pi, $pn, $prn, $pir);
			
			$nd = uriPrep ($domain, $did, "RC");
			$nr = uriPrep ($range, $rid, "RC");
			
			if ($doms[$pi])
				{$doms[$pi][$nd] = $nd;}
			else
				{$doms[$pi] = array($nd => $nd);} 
				
			if ($rans[$pi])
				{$rans[$pi][$nr] = $nr;}
			else
				{$rans[$pi] = array($nr => $nr);} 
			}	
		}
		
	$p = 1;
	
	foreach ($out as $key => $arr) 
		{
		$pi = $arr[0];
		
		$pn = uriPrep ($arr[1], $arr[0], "RP");
		$rpn = uriPrep ($arr[2], $arr[0], "RP", "I");
		
		if ($update)
			{updateProp ($pi, $pn, false);
			 updateProp ($pi, $rpn, true);}
		
		//Data Properties
		if (in_array("RC62.Value", $rans[$pi]))
			{
			$dprops .=  "
			
    <!-- http://rdf.ng-london.org.uk/2009/11/rrr_org.owl#".$pn." $p-->
		
    <owl:DatatypeProperty rdf:about=\"#".$pn."\">
        <rdfs:label xml:lang=\"en\">".$arr[1]."</rdfs:label>
";
			$p++;
	    foreach ($doms[$pi] as $k1 => $v1) 
				{$dprops .=   "        <rdfs:domain rdf:resource=\"#".$v1."\"/>
";			}
//    	foreach ($rans[$pi] as $k2 => $v2) 
//				{$dprops .=   "        <rdfs:range rdf:resource=\"#".$v2."\"/>
//";			
//				}

			$dprops .=   "        <rdfs:range rdf:resource=\"&rdfs;Literal\"/>
    </owl:DatatypeProperty>
";    	
			}
		else // Object properties
			{
			echo "
			
    <!-- http://rdf.ng-london.org.uk/2009/11/rrr_org.owl#".$pn." $p-->
		
    <owl:ObjectProperty rdf:about=\"#".$pn."\">
		    <rdfs:label xml:lang=\"en\">".$arr[1]."</rdfs:label>
";
			$p++;
	    foreach ($doms[$pi] as $k1 => $v1) 
				{echo "        <rdfs:domain rdf:resource=\"#".$v1."\"/>
";			}
    	foreach ($rans[$pi] as $k2 => $v2) 
				{echo "        <rdfs:range rdf:resource=\"#".$v2."\"/>
";			}

			echo "        <owl:inverseOf rdf:resource=\"#".$rpn."\"/>
    </owl:ObjectProperty>
		
    <!-- http://rdf.ng-london.org.uk/2009/11/rrr_org.owl#".$rpn." -->

    <owl:ObjectProperty rdf:about=\"#".$rpn."\">
		    <rdfs:label xml:lang=\"en\">".$arr[2]."</rdfs:label>
 ";
    	foreach ($rans[$pi] as $k2 => $v2) 
				{echo "      <rdfs:domain rdf:resource=\"#".$v2."\"/>
";			}
    	foreach ($doms[$pi] as $k1 => $v1) 
				{echo "      <rdfs:range rdf:resource=\"#".$v1."\"/>
";			}

			echo "        <owl:inverseOf rdf:resource=\"#".$pn."\"/>
    </owl:ObjectProperty>
					";    
			}
		}

	echo $dprops;
	
	$html = ob_get_contents();
	ob_end_clean(); // Don't send output to client
	
	return ($html);
	}
	*/
	
	
function fullPage($prp="", $cls="")
	{
	header('Content-type: text/xml; Charset=utf-8');
	ob_start();
	echo <<<END
<?xml version="1.0"?>

<rdf:RDF 
  xmlns:rdfs="http://www.w3.org/2000/01/rdf-schema#"
  xmlns:owl="http://www.w3.org/2002/07/owl#"
  xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
  xml:base="$GLOBALS[base]">
  <owl:Ontology rdf:about="$GLOBALS[base]">
	  <rdfs:comment xml:lang="en">The study of paintings by Raphael has produced an exceptional collection of material over the 500 years since their creation in the sixteenth century, covering their history and provenance as well as the materials and techniques used in their making.

The National Gallery, London, and its partners are pleased to present a large part of this wealth of information to specialists and the general public alike within the Research Research Resource, (http://cima.ng-london.org.uk/documentation) . Initially the project was based on the extensive studies of the ten paintings by Raphael in the Gallery collection, but it has now been developed to hold information provided by a growing number of other institutions and collaborators.

The database underneath the Research Research Resource has been constructed around a basic triple store with it's own specific ontology.  This ontology, though based on various previous projects, was allowed to develop as the pilot phase of the project progressed to determine the range of classes and properties required to describe the core data.  This document represents an mapping of this ontology expressed as owl/rdf.  Further work will be required to correct the structure and fully map this ontology to more standard ontologies and thesauri in the field of cultural heritage.

Copyright (c) 2010, The National Gallery London.
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
* The National Gallery, London nor the names of its partners may not be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
		</rdfs:comment>
  </owl:Ontology>
		
$cls

$prp    

</rdf:RDF>
END;

	$html = ob_get_contents();
	ob_end_clean(); // Don't send output to client
	
	return ($html);	
	}
?>

